/*
 
                                                                          
                     Copyright (C) 1999 Symantec Corp.                    
                            All Rights Reserved                           
                                                                          
       Information in this file is proprietary and confidential, and      
         may not be copied, reproduced or distributed in any manner       
      without the express written permission of Symantec Corp.            
                                                                          
 
*/

#ifndef _INC_DDIR                      // corresponding #endif is at end of file
   #define _INC_DDIR


//
// Definitions of connection directory entry classes
//

#define DDIR_DATA              1
#define DDIR_FAX               2
#define DDIR_VOICE             4
#define DDIR_TELNET            8
#define DDIR_FTP              16
#define DDIR_WWW              32
#define DDIR_MAIL             64
#define DDIR_NEWS            128
#ifdef REMOTE
#define DDIR_REMOTE          256
#endif // REMOTE

//
// Named Table indices.  Pass these values as the first parameter to
//    ReadNamedStruct().
//

#define TERMINAL               0
#define PROTOCOL               1
#define MODEM                  2
#define SETTINGS               3
#define FONT                   4
#define COLOR                  5
#define FAX                    6
#define EMAIL                  7
#define PCOLOR                 8
#define TELNET                 9
#define FTP                   10
#define NEWS                  11


#define  NAMED_TABLE_NAMELEN  25  // max length of name table entry including null

// 32-bit compatibility
#pragma pack(1)

typedef struct
{
   char name[NAMED_TABLE_NAMELEN];
   TERMINALSET tmset;
}  DDNamedTerminalTable;

typedef struct
{
   char name[NAMED_TABLE_NAMELEN];
   union
   {
      ZMODEMSET zm;
      KERMITSET k;
      XMODEMSET xm;
      DLPSET dlp;       //lint !e123
      CISBFILESET cisb;
      ASCIISET  ascii;
   };
}  DDNamedProtocolTable;

typedef struct
{
   char name[MODEM_NAME_LENGTH];
   MODEMSET md;
}  DDNamedModemTable;

typedef struct
{
   char name[NAMED_TABLE_NAMELEN];
   GENERALSET gn;
}  DDNamedSettingsTable;

typedef struct
{
   char name[NAMED_TABLE_NAMELEN];
   FONTSET font;
}  DDNamedFontTable;

typedef struct
{
   char name[NAMED_TABLE_NAMELEN];
   COLORSET color;
}  DDNamedColorTable;

typedef struct
{
   char name[NAMED_TABLE_NAMELEN];
   PCOLORSET pcolor;
}  DDNamedPColorTable;

typedef struct
{
   char name[NAMED_TABLE_NAMELEN];
   FAXSET fax;
}  DDNamedFaxTable;

typedef struct
{
   char name[NAMED_TABLE_NAMELEN];
   EMAILSET email;
}  DDNamedEmailTable;

typedef struct
{
   char name[NAMED_TABLE_NAMELEN];
   TELNETSET telnet;
}  DDNamedTelnetTable;

typedef struct
{
   char name[NAMED_TABLE_NAMELEN];
   PFTPSET ftp;
}  DDNamedFTPTable;

typedef struct
{
   char name[NAMED_TABLE_NAMELEN];
   NEWSSET newsset;
}  DDNamedNewsTable;

#pragma pack()

#endif   // _INC_DDIR

