////////////////////////////////////////////////////////////////////////////
//
//      BIOS.H  -  DO NOT MODIFY! (new additions are OK)
//
//      C header file for BIOS.DLC which defines:
//        - structures
//        - function prototypes
//        - manifest constants
//
////////////////////////////////////////////////////////////////////////////
//                                                                         
//                 Copyright (C) 1999 Symantec Corporation                 
//                            All Rights Reserved                          
//                                                                         
//      Information in this file is proprietary and confidential, and      
//        may not be copied, reproduced or distributed in any manner       
//    without the express written permission of Symantec Corp.             
//                                                                         
//

#ifndef EXPORTED
#define EXPORTED __declspec(dllexport)
#endif

typedef struct tagCOMM
{
   HANDLE hTxBuff;
   HANDLE hRxBuff;
   LPSTR btxptr;
   LPSTR txptr;
   LPSTR stxptr;
   LPSTR brxptr;
   LPSTR rxptr;
   LPSTR srxptr;
   int txmax;
   int txsize;
   int rxmax;
   int rxsize;
   BYTE xoffed;
   BYTE xoffsent;
   BYTE type;
   int rxcnt;
   int txcnt;
   BYTE instance;
   BYTE com_cts;
   BYTE com_dcd;
   DCB Int14dcb;
}COMM;

typedef struct tagNETWORK
{
   int type;
   int port;
   char name[12];
}NETWORK;


EXPORTED HANDLE   CALLBACK C_OpenComm( HWND, LPSTR, WORD, WORD, NETWORK *, BYTE );
EXPORTED int      CALLBACK C_CloseComm( int, NETWORK * );
EXPORTED int      CALLBACK C_FlushComm( int, int, NETWORK * );
EXPORTED int      CALLBACK C_ReadComm( int, LPSTR, int, NETWORK * );
EXPORTED int      CALLBACK C_WriteComm( int, LPSTR, int, NETWORK * );
EXPORTED int      CALLBACK C_GetCommError( int, COMSTAT *, NETWORK * );
EXPORTED int      CALLBACK C_UngetCommChar( int, char, NETWORK * );
EXPORTED int      CALLBACK C_SetCommBreak( int, NETWORK * );
EXPORTED int      CALLBACK C_ClearCommBreak( int, NETWORK * );
EXPORTED int      CALLBACK C_EscapeCommFunction( int, int, NETWORK * );
EXPORTED int      CALLBACK C_GetCommState( int, DCB *, NETWORK * );
EXPORTED int      CALLBACK C_SetCommState(  DCB *, NETWORK * );
EXPORTED int      CALLBACK C_DCD(unsigned, NETWORK *);
EXPORTED unsigned CALLBACK C_FindPortAddress(NETWORK *);
EXPORTED int      CALLBACK C_FastRate(int, unsigned, NETWORK *);
EXPORTED BOOL     CALLBACK C_Setup(HWND, LPSTR, NETWORK *);
EXPORTED DWORD    CALLBACK C_GetCaps( void );
EXPORTED BOOL     CALLBACK C_EnumConnections( int, LPSTR, HANDLE);
void     CenterDlg( HWND hDlg );
EXPORTED BOOL     CALLBACK AboutDlgProc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam );
EXPORTED void CALLBACK C_SetNewConnection(LPSTR lpszNetwork, LPSTR lpszModem);

int myint14( BYTE, int, BYTE );

#define _COM_INIT       0       /* init serial port */
#define _COM_SEND       1       /* send character */
#define _COM_RECEIVE    2       /* receive character */
#define _COM_STATUS     3       /* get serial port status */

#define IDS_CONNECT     1400

#define CBR_28800       28800

