/*
 
                                                                          
         File:   simpldlt.c                                              
                                                                          
  Description:   Testbed for .DLT testing                                
                                                                          
 
                                                                          
                  Copyright (C) 1999 Symantec Corporation                 
                             All Rights Reserved                          
                                                                          
       Information in this file is proprietary and confidential, and      
         may not be copied, reproduced or distributed in any manner       
     without the express written permission of Symantec Corp.             
                                                                          
 
*/

#define  STRICT
#include <windows.h>
#include <commdlg.h>
#include <stdio.h>                     // for EOF for fileio

#include "gpwindlx.h"                  // Only to define MAKEPROC for callback.h
#include "pwdlx.h"                     // Numerous definitions
#include "ddirdlx.h"                   // NamedTable structure definitions
#include "menudlx.h"                   // only to define ID_PLAYBACK
#include "cbackdlx.h"                  // For CALLBACK structure
#include "xdlt.h"                      // Define PW_DLT, the interface structure

#include "simpldlt.h"

#include <string.h>
#include <stdlib.h>                    // For ultoa

/*

  DLL linkage related globals.                                        

*/

HINSTANCE   hInst;                     // DLL Instance handle set during DLL startup


/*

                                                                    
 DLL entry and exit routines                                        
                                                                    

*/

int APIENTRY DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
   if (dwReason == DLL_PROCESS_ATTACH)
   {
      hInst = hInstance;   // save instance handle for dialog box and resources

   }
   else if (dwReason == DLL_PROCESS_DETACH)
   {

   }
   return 1;   // ok
}

/*

                                                                    
                      DLL Interface routines                        
                                                                    

*/

/*

  Window procedure for terminal window.                               

*/

LONG  EXPORTED FAR   PASCAL   DLTTerminalWinProc( HWND, UINT, WPARAM, LPARAM);

/*

  Application worker routine function prototypes.                     

*/

int   NEAR  PASCAL   RequestNumOfEmuls       ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   RequestEmulationName    ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   RequestEmulationNeeds   ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   RequestEmulationCaps    ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   Startup                 ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   Timer                   ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   Reset                   ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   ShutDown                ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   KeyChar                 ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   SnapShot_Printer        ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   SnapShot_File           ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   SnapShot_Clipboard      ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   ReadFromDisplay         ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   StartCapture            ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   EndCapture              ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   StartReplay             ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   EndReplay               ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   PauseReplay             ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   ContinueReplay          ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   TerminalWriteBuffer     ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   DoAdvancedSetupDialog   ( LPVOID, LPPW_DLT);
//int NEAR  PASCAL   TerminalPoll            ( LPVOID, LPPW_DLT); // Not used in PW3.0 DLT's.
int   NEAR  PASCAL   ComputeScrollRange      ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   SetupFinalSize          ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   SetupCaret              ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   RemoveCaret             ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   QueryEscape             ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   PerformEscape           ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   QueryString             ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   TerminalChanged         ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   MenuNotification        ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   SpecialKeys             ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   QueryRowColInfo         ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   TerminalPollExt         ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   SnapShot_Mail           ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   SnapShot_Capture        ( LPVOID, LPPW_DLT);
int   NEAR  PASCAL   SnapShot_Fax            ( LPVOID, LPPW_DLT);


/*

  Internal worker routine function prototypes.                        

*/

int            NEAR  PASCAL   GetInstanceDataIndexFromhWnd  ( HWND);
LPPW_DLT       NEAR  PASCAL   GetPW_DLTFromhWnd             ( HWND);
void           NEAR  PASCAL   ComputeRowColAndPaintRect     ( int, LPRECT, LPRECT);
void           NEAR  PASCAL   ProcessAChar                  ( int, BYTE);
void           NEAR  PASCAL   ProcessANormalChar            ( int, BYTE);
void           NEAR  PASCAL   RemoveCaretWorker             ( LPPW_DLT);
void           NEAR  PASCAL   SetupCaretWorker              ( int);
void           NEAR  PASCAL   TerminalVSCROLL               ( int, int, int);
void           NEAR  PASCAL   TerminalHSCROLL               ( int, int, int);
int            NEAR  PASCAL   DumpScreenToPrinter           ( int, HDC, int, int, int);
BOOL EXPORTED  FAR   PASCAL   AdvSetupDlgProc               ( HWND, UINT, WPARAM, LPARAM );
void           NEAR  PASCAL   ScrollToCursorWorker          ( LPPW_DLT);

/*

  Application specific globals.                                       

*/

#define  NUMROWS     24
#define  NUMCOLS     80

typedef  int   PASCAL   WORKERFN ( LPVOID, LPPW_DLT);
typedef  WORKERFN NEAR* NPWFN;
NPWFN JumpTable[] =
{
   RequestNumOfEmuls,                  // DLT_RequestNumOfEmuls         0
   RequestEmulationName,               // DLT_RequestEmulationName      1
   RequestEmulationNeeds,              // DLT_RequestEmulationNeeds     2
   RequestEmulationCaps,               // DLT_RequestEmulationCaps      3
   Startup,                            // DLT_Startup                   4
   Timer,                              // DLT_Timer                     5
   Reset,                              // DLT_Reset                     6
   ShutDown,                           // DLT_ShutDown                  7
   KeyChar,                            // DLT_KeyChar                   8
   SnapShot_Printer,                   // DLT_SnapShot_Printer          9
   SnapShot_File,                      // DLT_SnapShot_File             10
   SnapShot_Clipboard,                 // DLT_SnapShot_Clipboard        11
   ReadFromDisplay,                    // DLT_ReadFromDisplay           12
   StartCapture,                       // DLT_StartCapture              13
   EndCapture,                         // DLT_EndCapture                14
   StartReplay,                        // DLT_StartReplay               15
   EndReplay,                          // DLT_EndReplay                 16
   PauseReplay,                        // DLT_PauseReplay               17
   ContinueReplay,                     // DLT_ContinueReplay            18
   TerminalWriteBuffer,                // DLT_TerminalWriteBuffer       19
   DoAdvancedSetupDialog,              // DLT_DoAdvancedSetupDialog     20
   NULL,                               // DLT_Terminal                  21 // Replaced by TerminalPollExt below.
   ComputeScrollRange,                 // DLT_ComputeScrollRange        22
   SetupFinalSize,                     // DLT_SetupFinalSize            23
   SetupCaret,                         // DLT_SetupCaret                24
   RemoveCaret,                        // DLT_RemoveCaret               25
   QueryEscape,                        // DLT_QueryEscape               26
   PerformEscape,                      // DLT_PerformEscape             27
   QueryString,                        // DLT_QueryString               28
   TerminalChanged,                    // DLT_TerminalChanged           29
   MenuNotification,                   // DLT_MenuNotification          30
   SpecialKeys,                        // DLT_SpecialKeys               31
   QueryRowColInfo,                    // DLT_QueryRowColInfo           32
   TerminalPollExt,                    // DLT_TerminalPollExt           33
   SnapShot_Mail,                      // DLT_SnapShot_Mail             34
   SnapShot_Capture,                   // DLT_SnapShot_Capture          35
   SnapShot_Fax                        // DLT_SnapShot_Fax              36
}  ;


typedef  struct   tagEmulationInstData
{                                      // Data for each instance of emulation data
   BYTE  rgbyChars[NUMROWS][NUMCOLS];
   int   rowCur;                       // Current position of cursor
   int   colCur;
   int   rowTop;                       // Current position of upper left of viewport
   int   colLeft;
   int   ctRowsViewable;               // Size of current viewport
   int   ctColsViewable;
   int   pxFontHeight;                 // Font height, in pixels
   int   pxFontWidth;                  // Font width, in pixels
   WORD  ctTicksNoRXData;              // Number of clock ticks since active data was seen
   HFONT hfontOld;                     // Original font in DC
   FBPTR hReplayFile;                  // Handle to PW Stream Input file for
                                       //    replaying data to the screen.
                                       //    Set by call to StartReplay().
                                       //    Cleared by call to EndReplay().
   FBPTR hCaptureFile;                 // Handle to PW String Output file for
                                       //    writing comm data to.  Set by
                                       //    call to StartCapture().  Cleared
                                       //    by call to EndCapture().
   struct                              // Binary flags
   {
      int   LMouseClicked  :  1;       // True if a click & drag operation is in progress
      int   ReplayingFile  :  1;       // True if currently replaying a file
   }  f;
}  EMDATA;
typedef  EMDATA   FAR*  LPEMDATA;


struct   tagInstData
{
   HWND        hWndTerminal;           // Terminal window handle of caller
   HANDLE      hEmData;                // Handle to globally alloc'd instance data
   #pragma  pack(4)
   LPEMDATA    lpEmData;               // Points to gobally alloc'd instance data
   WNDPROC     lpOldTermWndProc;       // Stores the old lpfnTerminal
   LPPW_DLT    lppw_dlt;               // Position of instance's pw_dlt structure
   #pragma  pack()
}  rgInstData[16] = {0};               // Can have no more than 16 instances running at once


struct   tagEmulationNeeds             // What do these emulations need?
{
   BYTE        Name[50];               // PW only allows 20
   NEED_FLAGS  Needs;
   unsigned char szACCName[MAXFILENAME];
}  EmulNeedsArray[2] =
   {
      {                                // Emulation 1
         "TESTDLT Emulation 1",                 // name
         NF_CONSTANT_TIMER | NF_ADVANCED_SETUP, // needs
         "vtxdlt.acc"
      },
      {                                // Emulation 2
         "Second TESTDLT Emulation",            // name
         NF_NONE,                               // needs
         ""
      },
   };


/*

  Useful macros.                                                      

*/

#define  NumElements(array)   (sizeof(array)/sizeof(array[0]))

/*

                                                                    
 Application callable entry points                                  
                                                                    

*/

/*
 
                                                                          
         Name:               DLT_Interface                               
                                                                          
  Description: Top level PW-callable DLL routine                         
                                                                          
      Purpose: Provide the single entrypoint for most calls from PW      
                                                                          
    Arguments:                                                           
                                                                          
      Returns:                                                           
                                                                          
      Globals:                                                           
                                                                          
     Modifies:                                                           
                                                                          
    Called By:                                                           
                                                                          
      Example:                                                           
                                                                          
     Warnings:                                                           
      Caveats:                                                           
        Notes:                                                           
                                                                          
    Algorithm:                                                           
                                                                          
  Extrn Files:                                                           
                                                                          
     See Also:                                                           
                                                                          
    Author(s): Henry Mitchel, Rodger Schuermann                          
                                                                          
      History: 09/08/92  HMM - Created Header                            
                                                                          
 
*/

int   EXPORTED FAR   PASCAL   DLT_Interface
(
   int      nFunctionCode,             // Function switch
   LPVOID   lpvoid,                    // General pointer to whatever is needed
   LPPW_DLT lppw_dlt                   // Pointer to PW_DLT structure
)
{
   #if DEBUG && DEBUG_DLT
   char  szBuffer[128];
   wsprintf( szBuffer, "DLT saw %d\r\n", nFunctionCode);
   OutputDebugString( szBuffer);
   #endif   // DEBUG && DEBUG_DLT

   if ((nFunctionCode < NumElements(JumpTable)) &&
       (JumpTable[nFunctionCode]))
      return JumpTable[nFunctionCode]( lpvoid, lppw_dlt);
   else
      return DLT_FUNCTION_NOT_IMPLEMENTED;
}                                      // End of DLT_Interface



/*

                                                                    
 Internal routines                                                  
                                                                    

*/

int   NEAR  PASCAL   RequestNumOfEmuls
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   *(lpRequestNumOfEmulsStruct)lpvoid,
   //             the nEmulations field empty.
   //          lppw_dlt may be NULL, do not reference it
   // Return:  Number of emulations supported by this DLT, typically 1,
   //             in the struct provided.
   //          Also reset the passed in structure size to provide version check.

   #define  lp ((lpRequestNumOfEmulsStruct)lpvoid)
   if (!lp)                            // Error check, don't care about lppw_dlt
      return FALSE;
   lp->wSize = sizeof(RequestNumOfEmulsStruct);
   lp->nEmulations = NumElements(EmulNeedsArray);
   #undef   lp
   return TRUE;
}


int   NEAR  PASCAL   RequestEmulationName
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   *(lpRequestEmulationNameStruct)lpvoid, with
   //             nEmulation being the number of the emulation for
   //                which the name is desired.
   //             nMaxLen is the size of the buffer; do not exceed it.
   //             lpszEmulationName points to the receiving buffer.
   //          lppw_dlt may be NULL, do not reference it
   // Return:  Fill in the buffer with the default name of the
   //             emulation.
   //          Also reset the passed in structure size to provide version check.
   ///         Return TRUE if successful, FALSE if not.

   #define  lp ((lpRequestEmulationNameStruct)lpvoid)
   if (!lp)                            // Error check
      return FALSE;
   lp->wSize = sizeof(RequestEmulationNameStruct);
   if (lp->nMaxLen)                    // Error check: only do something if
   {                                   //    have place to put returned result
      if (lp->nEmulation < NumElements(EmulNeedsArray))
      {
         _fstrncpy(  lp->lpszEmulationName,  // Copy in name
                     EmulNeedsArray[lp->nEmulation].Name,
                     lp->nMaxLen-1);
         *(lp->lpszEmulationName + lp->nMaxLen - 1) = 0; // Null terminate
         return TRUE;
      }
      else                             // Emulation number requested was out of range
      {
         *(lp->lpszEmulationName) = 0;
         return FALSE;
      }
   }
   else
      return FALSE;
   #undef   lp
}


int   NEAR  PASCAL   RequestEmulationNeeds
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   *(lpRequestEmulationNeedsStruct)lpvoid, with
   //             nEmulation being the number of the emulation for
   //                which the name is desired.
   //             nf is empty.
   //             rgptResAvail[] is an array of POINTS.  The x and y values
   //                are horizontal and vertical resolutions.  Returning
   //                this parameter is optional.
   //          lppw_dlt may be NULL, do not reference it
   // Return:  Fill in the nf bit array with #defines from the NEED_FLAGS
   //             definition to indicate to PW what needs the DLT has.
   //          Fill in rgptResAvail[] if the emulation supports multiple
   //             resolutions, otherwise clear it to 0.
   //          Also reset the passed in structure size to provide version check.
   ///         Return TRUE if successful, FALSE if not.

   #define  lp ((lpRequestEmulationNeedsStruct)lpvoid)
   if (!lp)                            // Error check
      return FALSE;
   lp->wSize = sizeof(RequestEmulationNeedsStruct);
   if (lp->nEmulation < NumElements(EmulNeedsArray))
   {
      lp->nf = EmulNeedsArray[lp->nEmulation].Needs;
                                       // Assuming that multiple resolutions are not supported ...
      _fmemset( lp->rgptResAvail, 0, sizeof(lp->rgptResAvail));
      return TRUE;
   }
   else                                // Emulation number requested was out of range
      return FALSE;
   #undef   lp
}


int   NEAR  PASCAL   RequestEmulationCaps
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   *(lpRequestEmulationCapsStruct)lpvoid, with
   //             nEmulation being the number of the emulation for
   //                which the name is desired.
   //             tmgf is zeroed out.
   //          lppw_dlt may be NULL, do not reference it
   // Return:  Fill in the tmgf structure to indicate to PW what menu items
   //             must be grayed out.
   //          Also reset the passed in structure size to provide version check.
   ///         Return TRUE if successful, FALSE if not.

   #define  lp ((lpRequestEmulationCapsStruct)lpvoid)
   if (!lp)                            // Error check
      return FALSE;
   lp->wSize = sizeof(RequestEmulationCapsStruct);
                                       // Set default to no graying
   _fmemset( &lp->tmgf, 0, sizeof(TERMINAL_MENU_GRAYING_FLAGS));
   switch( lp->nEmulation)
   {
      case  0:                         // Make all graying
         _fmemset( &lp->tmgf, 0xFF, sizeof(TERMINAL_MENU_GRAYING_FLAGS));
         return TRUE;
      case  1:                         // Make none graying
         _fmemset( &lp->tmgf, 0, sizeof(TERMINAL_MENU_GRAYING_FLAGS));
         return TRUE;
//    case  1:                         // Make some graying
//       lp->tmgf.fACTION_PRINT        = 1;
//       lp->tmgf.fPLAYBACK            = 0;
//       lp->tmgf.fACTION_LOG          = 0;
//       lp->tmgf.fCOPY                = 1;
//       lp->tmgf.fPASTE               = 1;
//       lp->tmgf.fSCREEN_TO_CLIP      = 0;
//       lp->tmgf.fSCREEN_TO_LOG       = 1;
//       lp->tmgf.fSCREEN_TO_FILE      = 1;
//       lp->tmgf.fSCREEN_TO_PRINTER   = 0;
//       lp->tmgf.fSCREEN_TO_BUFF      = 1;
//       lp->tmgf.fSCREEN_TO_MAIL      = 1;
//       lp->tmgf.fBUFF_TO_CLIP        = 1;
//       lp->tmgf.fBUFF_TO_LOG         = 1;
//       lp->tmgf.fBUFF_TO_FILE        = 1;
//       lp->tmgf.fBUFF_TO_PRINTER     = 1;
//       lp->tmgf.fBUFF_TO_MAIL        = 1;
//       lp->tmgf.fFILECLIP            = 1;
//       lp->tmgf.fACTION_PAUSE        = 1;
//       lp->tmgf.fTERM_CLEAR          = 1;
//       lp->tmgf.fTERM_RESET          = 0;
//       lp->tmgf.fACTION_CHAT         = 0;
//       lp->tmgf.fMONITOR             = 0;
//       lp->tmgf.fFIND                = 1;
//       lp->tmgf.fSCREEN_TO_FAX       = 1;
//       lp->tmgf.fBUFF_TO_FAX         = 1;
//       return TRUE;

      default:
         return FALSE;
   }                                   // End of switch
   #undef   lp
}


int   NEAR  PASCAL   Startup
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   int         i;                      // Loop counter
// TEXTMETRIC  tm;                     // Text description buffer

   // Input:   *(lpStartupStruct)lpvoid, with
   //             nEmulationRequested the number of the emulation in this .DLT
   //                to startup.  It is expected that this information will
   //                be stored internally to the .DLT.
   //             iPointSizeRequested is the character point size that the
   //                user would like to see.  If it cannot be accomodated
   //                that is OK.
   // Return:  iFontWidth set to the width in pixels of a single character cell.
   //          iFontHeight set to the Height in pixels of a single character cell.
   //          wRows set to the number of rows of character cells on the screen.
   //          wColumns set to the number of columns of character cells on the screen.
   //          NOTE: these return values are used to attempt to set the display window
   //             size to exactly the size needed by the emulation.  They must have
   //             reasonable values and must not be zero.  Although they are stored
   //             here as WORDs, internally to PW the rows and columns are BYTES,
   //             and so they must be between 0 and 255.  Larger values will cause
   //             problems.
   //          lppw_dlt->iDLLMagicIndex should be set to a value that serves to
   //             distinguish this instance of the program from all others.
   //             Most likely, it would be an index into an array of handles or
   //             pointers to the .DLT allocated per instance data structures.
   //             Perhaps it could be a window or instance handle.  Whatever
   //             works for the .DLT.
   //          lppw_dlt->lpExtraBytes contains whatever structure the that emulation
   //             put there using DoAdvancedSetup().  If there has been no invokation
   //             of DoAdvancedSetup(), then the area will be filled with 0's.
   //          Set the window handles as needed.  BE CAREFUL to handle multiple
   //             instances PW during execution.
   //          Also reset the passed in structure size to provide version check.
   //          Return TRUE if successful, FALSE if not.

   #define  lp ((lpStartupStruct)lpvoid)
   if (!lp || !lppw_dlt)               // Error check
      goto abort0;

   lp->wSize = sizeof(StartupStruct);

// #if   DEBUG
   //
   // Special hack debug code!!!!!!!!!!!!!!!!!!!!!!
   // GENERALSET is defined as a structure in PW.H.
   // P_ReadNamedTable returns the address of the GENERALSET structure
   //    in PW.
   //
   {
      GENERALSET far* lpGenSet = &((DDNamedSettingsTable far*)P_ReadNamedStruct( SETTINGS, -1))->gn;
      if (lpGenSet)
         OutputDebugString( lpGenSet->dwnload);
      else
         OutputDebugString( "No download path found");
      OutputDebugString( "\r\n");
   }
// #endif   // DEBUG

   //
   // Swap window procedure.
   //
   for(  i=0; i<NumElements(rgInstData); i++)
   {
      if (!rgInstData[i].hWndTerminal) // Is this element free?
         break;
   }
   if (i == NumElements(rgInstData))   // Ran off the end!  No space!
      goto abort0;

   lppw_dlt->iDLLMagicIndex = i;       // Set the "magic cookie"

   rgInstData[i].lppw_dlt = lppw_dlt;  // Remember the interface structure address

   rgInstData[i].hWndTerminal = lppw_dlt->hWndTerminal;  // Swap the window procedure
   rgInstData[i].lpOldTermWndProc = (WNDPROC)SetWindowLong( lppw_dlt->hWndTerminal, GWL_WNDPROC, (LONG)DLTTerminalWinProc);

   //
   // Setup instance-specific memory buffer.
   //
   rgInstData[i].hEmData = GlobalAlloc( GMEM_MOVEABLE | GMEM_ZEROINIT, sizeof( EMDATA));
   if (!rgInstData[i].hEmData)
      goto abort1;

   rgInstData[i].lpEmData = GlobalLock( rgInstData[i].hEmData);
   if (!rgInstData[i].lpEmData)
      goto abort2;

   //
   // Setup instance-specific data.
   //
   switch( lp->nEmulationRequested)
   {
      case  0:
         #if   DEBUG
         OutputDebugString( "DLT Startup saw emulation 0\r\n");
         #endif
         break;
      case  1:
         #if   DEBUG
         OutputDebugString( "DLT Startup saw emulation 1\r\n");
         #endif
         break;
      default:
         ((T_StatusLineDirect)lppw_dlt->lpcbs->StatusLineDirect)( "DLT Emulation could not be initialized");
         goto abort0;
   }                                   // End of switch

   //
   // Copy in accelerator table name.
   //
   _fstrncpy( lp->szKeyboardAcceleratorFileName,
              EmulNeedsArray[lp->nEmulationRequested].szACCName,
              lp->nMaxFileNameLen-1);
                                       // Null terminate
   *(lp->szKeyboardAcceleratorFileName + lp->nMaxFileNameLen - 1) = 0;

   //
   // Clear the terminal to its default state.
   //
   rgInstData[i].lpEmData->hfontOld = SelectObject( lppw_dlt->hDCTerminal, GetStockObject( OEM_FIXED_FONT));
   _fmemset( rgInstData[i].lpEmData->rgbyChars, ' ', sizeof(rgInstData[i].lpEmData->rgbyChars));

   //
   // Good return.
   //
   return TRUE;

   //
   // Abort returns.
   //
abort2:
   GlobalFree( rgInstData[i].hEmData);
abort1:
   SetWindowLong( lppw_dlt->hWndTerminal, GWL_WNDPROC, (LONG)rgInstData[i].lpOldTermWndProc);
   _fmemset( &rgInstData[i], 0, sizeof(struct tagInstData));
abort0:
   return FALSE;
   #undef   lp
}


int   NEAR  PASCAL   Timer
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Called off of the timer every 55 msec if during RequestEmulationNeeds
   //    the NF_CONSTANT_TIMER flag is set in the RequestEmulationNeedsStruct.nf
   //    field before returning.
   // Characters MUST NOT be read from or written to the commports during this
   //    call.  This is only for internal maintenance which must happen on a
   //    continuous basis, such as blinking the screen.
   // No dialogs or MessageBoxes may be displayed during this call.  Doing so
   //    will compromise the integrity of PW.
   // No structure is currently defined for it.
   #if   DEBUG
// OutputDebugString( "5-");
   #endif
   return TRUE;
}


int   NEAR  PASCAL   Reset
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Called to soft reset the current emulation.  Also called after a Startup.
   //    lpvoid is NULL, lp_pwdlt is valid.

   int   i;                            // rgInstData index

   if (!lppw_dlt)
      return FALSE;
   else
      i  = lppw_dlt->iDLLMagicIndex;


   /*
   
     Initialize the screen. 
   
   */
   //
   // Initialize the internal data structure.
   //
   _fmemset( rgInstData[i].lpEmData->rgbyChars, ' ', sizeof(rgInstData[i].lpEmData->rgbyChars));
   rgInstData[i].lpEmData->rowCur = 0;
   rgInstData[i].lpEmData->colCur = 0;
   #if   DEBUG                         // Initialize buffer to something useful
   {
      int   nRow, nCol, lenTarget;
      for(  nRow = 0; nRow < NUMROWS; nRow++)
      {
         lenTarget = wsprintf( &rgInstData[i].lpEmData->rgbyChars[nRow][0], "Line %d", nRow);
         rgInstData[i].lpEmData->rgbyChars[nRow][lenTarget] = ' ';   // Remove terminating NULL
         for(  nCol = NUMCOLS-16; nCol < NUMCOLS; nCol++)
            rgInstData[i].lpEmData->rgbyChars[nRow][nCol] = (BYTE)(nRow*16 + nCol);
      }                                // End of for
   }
   #endif   //DEBUG

   //
   // Initialize the hDC.  Note that the hDC is permanent and will not be
   //    modified until the emulation is shutdown.
   //
   #define CR_YELLOW 0x0000FFFF
   #define CR_BLACK  0x00000000

   SetTextColor( lppw_dlt->hDCTerminal, CR_YELLOW);   // Yellow on black
   SetBkColor( lppw_dlt->hDCTerminal, CR_BLACK);
                                                      // Load desired font
   SelectObject( lppw_dlt->hDCTerminal, GetStockObject( OEM_FIXED_FONT));

   //
   // Set the "overspray" color to the same color as the background color.
   //    If you don't, there will be border of blue around the terminal
   //    window but inside the terminal border.
   //
   ((T_SetOverSprayColor)lppw_dlt->lpcbs->SetOverSprayColor)( CR_BLACK);
   #undef CR_YELLOW
   #undef CR_BLACK

   //
   // Initialize the caret.
   //
   if (*lppw_dlt->lpTerminalHasCaret)
      SetupCaretWorker( i);

   //
   // Force repaint of the terminal window.
   //
   InvalidateRect( lppw_dlt->hWndTerminal, NULL, FALSE);

   return TRUE;
}


int   NEAR  PASCAL   ShutDown
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   int i;

   // Input:   nothing
   // Return:  TRUE if successful, FALSE if not.  If not successful the emulation
   //          will remain in control and calls will continue to come to the .DLT.

   #if   DEBUG
   OutputDebugString( "DLT Shutdown called\r\n");
   #endif

   i = lppw_dlt->iDLLMagicIndex;
   SelectObject( lppw_dlt->hDCTerminal, rgInstData[i].lpEmData->hfontOld);
   SetWindowLong( lppw_dlt->hWndTerminal, GWL_WNDPROC, (LONG)rgInstData[i].lpOldTermWndProc);
   GlobalUnlock( rgInstData[i].hEmData);
   GlobalFree( rgInstData[i].hEmData);
   _fmemset( &rgInstData[i], 0, sizeof(struct tagInstData));
   return TRUE;
}


int   NEAR  PASCAL   KeyChar
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   BYTE  szBuf[3];

   // Input:   *(WPARAM FAR*)lpvoid pointing to the wParam of the WM_CHAR
   //             message.
   // Return:  None.

   #define  lp ((WPARAM FAR*)lpvoid)
   if (!lp)                            // Error check
      return FALSE;
   else
   {
      szBuf[0] = '>';
      szBuf[1] = (BYTE)*lp;
      szBuf[2] = '<';
      ((T_AddToTXBuf)lppw_dlt->lpcbs->AddToTXBuf)( szBuf, 3, FALSE, FALSE);
      return TRUE ;
   }

   #undef   lp
}


int   NEAR  PASCAL   SnapShot_Printer
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   *(lpSnapShot_PrinterStruct)lpvoid, with
   //             lprPage pointing to a rect defining the borders of the page
   //                in device coordinates.  Printing should occur only within these borders.
   //             lpxCurrent pointing to the current horizontal position on the page.
   //                This can be modified by the DLL to force further printing by
   //                PW to begin at the new position.
   //             lpyCurrent pointing to the current vertical position on the page.
   //                This can be modified by the DLL to force further printing by
   //                PW to begin at the new position.
   //             lpLineHeight pointing to the current height in device units of
   //                a single printer line in the currently selected font.
   //          *lppw_dlt->lphPrinterDC will be an open printer DC.  The font which
   //             was selected by the user will be selected into this DC.  If the
   //             font or other attributes of the DC are changed, the original values
   //             should be restored before this function ends.
   //
   // Return:  Write the screen image to the printer.
   //          Also reset the passed in structure size to provide version check.
   //          Return TRUE if successful, FALSE if not.
   //
   // Note:    The NewPage callback function is available for calling
   //          from this function.  The NewPage function ejects the page and handles
   //          internal bookkeeping for PW.  Because PW's internal state will change
   //          across a NewPage call, the passed in variables defining the position
   //          on the page should be dereferenced again prior to being used.  Also,
   //          the default font is reloaded into the DC after each call to NewPage
   //          (we found it was necessary to work around some buggy drivers for the
   //          HP LaserJet series of printers).  This means that you should reload
   //          your printer font after each call to NewPage.
   //
   // Note:    NewPage will automatically be called after this function ends, so
   //          there is no need to do a final NewPage.
   //
   // Note:    Although pointers are passed in the structure, it would be dangerous
   //          to use them to write into PW and change it's internal state.  The
   //          results of doing so are undefined.
   //
   // Note:    The flag determining whether or not the printing should be graphics
   //          or font based is set on an emulation by emulation basis, and so
   //          should be saved in this emulation's lppw_dlt->lpExtraBytes.

   #define  lp ((lpSnapShot_PrinterStruct)lpvoid)

   int   i;                            // Instance data index
   int   x, y;                         // Current position on the paper.
   int   lh;                           // LineHeight
   RECT  rPage;                        // Rectangle defining the page

   if (!lppw_dlt || !lp || !lppw_dlt->lphPrinterDC)   // Error check
      return FALSE;
   i = lppw_dlt->iDLLMagicIndex;       // Get local copies of needed data
   x = *lp->lpxCurrent;
   y = *lp->lpyCurrent;
   lh = *lp->lpLineHeight;
   CopyRect( &rPage, lp->lprPage);

   /*
   
     As an example, we will first check that there is enough room to     
        print on the current page, and do so if there is enough room.    
        Next we will get the next page and print text there, and then    
        a simple graphic.                                                
   
   */

   //
   // Get to the beginning of the next line.
   //
   if (x > rPage.left)                 // Currently in the middle of a line
   {
      x = rPage.left;                  // Reposition to left margin and
      y += lh;                         //    one line down.
   }

   //
   //  Check if there is room on the current page and print text
   //    if there is.
   //
   if (rPage.bottom - y >= NUMROWS * lh)
      DumpScreenToPrinter( i, *lppw_dlt->lphPrinterDC, x, y, lh);

   //
   //  Start a new page and dump the text there, also.  The current
   //    position on the screen will change across the NewPage call.
   //
   ((T_NewPage)lppw_dlt->lpcbs->NewPage)();
   x = *lp->lpxCurrent;                // Get new values from PW.
   y = *lp->lpyCurrent;
   y = DumpScreenToPrinter( i, *lppw_dlt->lphPrinterDC, x, y, lh);

   //
   // Draw a graphic in the remaining space on the page and eject page.
   //
   Rectangle( *lppw_dlt->lphPrinterDC, x, y, rPage.right, rPage.bottom);
   Ellipse( *lppw_dlt->lphPrinterDC, x, y, rPage.right, rPage.bottom);
   ((T_NewPage)lppw_dlt->lpcbs->NewPage)();

   return TRUE;
   #undef   lp
}


int   NEAR  PASCAL   SnapShot_File
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   *(lpSnapShot_FileStruct)lpvoid, with
   //             hFile pointing to an open and ready to write file.
   //             fAppend is TRUE if the file is in append mode, that is, if
   //                the file already contains data.
   //
   // Return:  Write the screen image to the file.
   //          Also reset the passed in structure size to provide version check.
   //          Return TRUE if successful, FALSE if not.
   //
   // Note:    The file will be closed upon completion of this function.
   //
   // Note:    The flag defining whether the output will be text, bitmap, or
   //          mbp internal format is kept by this emulation in its
   //          lppw_dlt->lpExtraBytes area.  Currently, mbp internal format
   //          makes no sense because there is no way to reload it--but there
   //          should be--and perhaps in a later version it can be incorporated.
   //          The bitmap and text formats make some sense, and should be
   //          handled here.
   //
   //          Writing a bitmap when fAppend is true does not make sense.
   //          Just return FALSE.

   #define  lp ((lpSnapShot_FileStruct)lpvoid)
   if (!lp || !lppw_dlt || !lp->hFile) // Error check
      return FALSE;

   lp->wSize = sizeof(SnapShot_FileStruct);
                                       // Write a test string out through PW
   ((T_flputs)lppw_dlt->lpcbs->flputs)( "Hello from inside the .DLT\n", lp->hFile);
   return TRUE;

   #undef   lp
}


int   NEAR  PASCAL   SnapShot_Clipboard
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lpvoid NULL.
   //
   // Return:  Write the screen image to the clipboard in the appropriate format.
   //          Return TRUE if successful, FALSE if not.
   //
   // Note:    A flag that the emulation keeps in its lppw_dlt->lpExtraBytes area
   //          defines the format of the data put into the clipboard (either
   //          bitmap or text).

   return TRUE;
}


int   NEAR  PASCAL   ReadFromDisplay
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   *(lpReadFromDisplayStruct)lpvoid, with
   //             colStart being the column at which to start
   //             rowStart being the row in which to start
   //             lenRead being the number of characters to read
   //             lpDest pointing to a receiving buffer.
   //
   // Return:  Retrieve the data from the screen.
   //          Also reset the passed in structure size to provide version check.
   //          Return TRUE if successful, FALSE if not.
   //
   // Note:    The return string does NOT have to be null terminated.
   //          If the length requested runs beyond the end of the line, the string
   //             is continued with the next line.
   //          If the length requested runs off the end of the screen, the string
   //             will be padded to length with nulls.
   //          Any graphics character which cannot reasonably be interpreted will
   //             be replaced by a space in the string.
   //          A double wide character should have its logical character extracted
   //             and placed in the string only once.
   //          A double high character can possibly show up in the string twice,
   //             first on the top row and second on the bottom row.

   #define  lp ((lpReadFromDisplayStruct)lpvoid)
   if (!lp || !lppw_dlt || !lp->lpDest || !lp->lenRead)  // Error check
      return FALSE;

   _fmemset( lp->lpDest, 'G', lp->lenRead);  // 'G' for Garbage -- NEEDS CODE

   return TRUE;
   #undef   lp
}


int   NEAR  PASCAL   StartCapture
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   *(lpStartCaptureStruct)lpvoid, with
   //             hCaptureFile being an open and ready to write stream file.
   //
   // Return:  Write all incoming de-packetized data to the file until EndCapture()
   //             is seen.
   //          Also reset the passed in structure size to provide version check.
   //          Return TRUE if successful, FALSE if not.

   #define  lp ((lpStartCaptureStruct)lpvoid)
   if (!lp || !lppw_dlt || !lp->hCaptureFile)   // Error check
      return FALSE;

   #if DEBUG
   ((T_flputs)lppw_dlt->lpcbs->flputs)( "Capture file is starting up.\n", lp->hCaptureFile);
   #endif // DEBUG

   rgInstData[lppw_dlt->iDLLMagicIndex].lpEmData->hCaptureFile = lp->hCaptureFile;

   return TRUE;
   #undef   lp
}


int   NEAR  PASCAL   EndCapture
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lpvoid NULL
   // Return:  nothing, just clear the internal state, if there is any.

   #if DEBUG
   ((T_flputs)lppw_dlt->lpcbs->flputs)( "Capture file is ending.\n", rgInstData[lppw_dlt->iDLLMagicIndex].lpEmData->hCaptureFile);
   #endif // DEBUG

   rgInstData[lppw_dlt->iDLLMagicIndex].lpEmData->hCaptureFile = NULL;

   return TRUE;
}


int   NEAR  PASCAL   StartReplay
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lpvoid NULL
   //
   // Return:  Setup to read the file during terminal polling.
   //          Return TRUE if successful, FALSE if not.

   if (!lppw_dlt)                      // Error check
      return FALSE;

   rgInstData[lppw_dlt->iDLLMagicIndex].lpEmData->f.ReplayingFile = TRUE;
   return TRUE;

   #undef   lp
}


int   NEAR  PASCAL   EndReplay
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lpvoid points to nothing.
   // Return:  Stop playing the file.  It will be closed after this function is called.

   rgInstData[lppw_dlt->iDLLMagicIndex].lpEmData->f.ReplayingFile = FALSE;
   return TRUE;
}


int   NEAR  PASCAL   PauseReplay
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lpvoid points to nothing.
   // Return:  Stop playing the file temporarily.

   rgInstData[lppw_dlt->iDLLMagicIndex].lpEmData->f.ReplayingFile = FALSE;
   return TRUE;
}


int   NEAR  PASCAL   ContinueReplay
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lpvoid NULL.
   // Return:  Continue replaying the file.

   rgInstData[lppw_dlt->iDLLMagicIndex].lpEmData->f.ReplayingFile = TRUE;
   return TRUE;
}


int   NEAR  PASCAL   TerminalWriteBuffer
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   *(lpTerminalWriteBufferStruct)lpvoid, with
   //             colStart being the column at which to start
   //             rowStart being the row in which to start
   //             lenWrite being the number of character in the buffer
   //             lpSrc pointing to a source buffer
   //
   // Return:  Write the data to the screen.
   //          Also reset the passed in structure size to provide version check.
   //          Return TRUE if successful, FALSE if not.

   #define  lp ((lpTerminalWriteBufferStruct)lpvoid)

   int      i;                         // Instance data index
   int      lenWrite;                  // Temporary to avoid hacking passed in structure
   LPSTR    lpSrc;                     // Temporary to avoid hacking passed in structure

   if (!lp || !lppw_dlt)               // Error check
      return FALSE;

   i        = lppw_dlt->iDLLMagicIndex;// Get local copies of needed data
   lpSrc    = lp->lpSrc;
   lenWrite = lp->lenWrite;

   if (rgInstData[i].lpEmData->f.LMouseClicked)
      return FALSE;                    // Cannot write when a selection is on the screen!

   /*
   
     If the terminal owns the caret, hide it. 
   
   */

   if(*lppw_dlt->lpTerminalHasCaret)
      RemoveCaretWorker( lppw_dlt);

   /*
   
     Set the position of the logical cursor, if requested.  It is        
        possible that the position will be requested without any text    
        to display; in such a case the cursor should still be positioned.
   
   */

   if (lp->fUseRowCol)                 // Set the cursor position
   {
      if (lp->colStart >= 0 && lp->colStart < NUMCOLS)
         rgInstData[i].lpEmData->colCur = lp->colStart;
      if (lp->rowStart >= 0 && lp->rowStart < NUMROWS)
         rgInstData[i].lpEmData->rowCur = lp->rowStart;
   }

   /*
   
     Write the characters to the terminal stream. 
   
   */

   while (lenWrite--)
      ProcessAChar( i, *lpSrc++);

   /*
   
     Restore caret removed above. 
   
   */

   if(*lppw_dlt->lpTerminalHasCaret)
      SetupCaretWorker( i);

   return TRUE;
   #undef   lp
}


int   NEAR  PASCAL   DoAdvancedSetupDialog
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   *(lpDoAdvancedSetupDialogStruct)lpvoid, with
   //             hWndParent the handle of the window that will be the parent
   //                of the dialog box.
   //             nEmulation is the number of the emulation to be set.
   //             lpExtraBytes is the place to get and put the data
   //             lenExtra is the maximum number of bytes available for the data
   //             uExtraUsed is the number of bytes actually used
   //          Create a dialog box to access and modify the structure
   //             VTX_OPTIONS and save the VTX_OPTIONS structure in the area
   //             pointed to by lpExtraBytes.  The maximum length you use
   //             is in lenExtra.  Return the amount used--for
   //             example sizeof(VTX_OPTIONS)--in uExtraUsed.
   //
   // Important:  lppw_dlt is NOT USABLE in this situation, because the
   //             emulation in question may not have actually been loaded!
   //
   // Return:  Pop up a dialog and get the information the emulation needs.
   //          Also reset the passed in structure size to provide version check.
   ///         Return TRUE if successful, FALSE if not.

   #define  lp ((lpDoAdvancedSetupDialogStruct)lpvoid)

   if (!lp)                            // Error check
      return FALSE;
   lp->wSize = sizeof(DoAdvancedSetupDialogStruct);

   DialogBoxParam( hInst, MAKEINTRESOURCE(1000), lp->hWndParent,
      AdvSetupDlgProc, (LPARAM)lp);

   #undef   lp
}


int   NEAR  PASCAL   ComputeScrollRange
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lp points to a ComputeScrollRangeStruct, defined in xdlt.h
   // Function:Figure out if the terminal window can fully fit within the
   //             passed in client area.  If so, return the scrollbar range
   //             and scrollbar position both set to 0.  If not, then scrollbars
   //             will be provided by the display window.  The function should
   //             return a scrollbar range and scrollbar position which make
   //             sense to the terminal.
   //          This function is essentially a "try this scenario" function.  It
   //             should not take any time-consuming action, such as modifying the
   //             internal
   //             state of the emulation.  It is called whenever the size of the
   //             display window changes; first to see if a vertical scrollbar is
   //             needed, second to see if a horizontal scrollbar is needed (with
   //             the space for the vertical scrollbar removed from the rectangle
   //             if a vertical scrollbar was needed), and third to see if
   //             a vertical scrollbar is needed once a horizontal scrollbar was
   //             added.  (Whew!)
   //          The values returned from the last call to this function will be
   //             used to set up the scrollbars, and then the SetupFinalSize()
   //             procedure will be called with the final size of the window
   //             set and the scrollranges actually set passed in.
   //          There are some non-trivial cases to handle here.  For example,
   //             if the previous state of the terminal window was
   //             only three lines high and the window had been scrolled to the
   //             bottom three lines, and now the new window size has room for
   //             5 lines, then the viewport into the terminal window will need
   //             to scroll up two lines, and the scrollbars adjusted accordingly.
   //
   // Return:  Return the lp->sb_range and lp->iPos variables set properly.
   //          Also reset the passed in structure size to provide version checking.
   //          Return TRUE if successful, FALSE if not.

   #define  lp ((lpComputeScrollRangeStruct)lpvoid)

   int      i;                         // Array index
   int      iMin, iMax, iPos;          // Returned values
   TEXTMETRIC  tm;

   if (!lp || !lppw_dlt)               // Error check
      return FALSE;
   lp->wSize = sizeof(ComputeScrollRangeStruct);
   i  =  lppw_dlt->iDLLMagicIndex;

   // Get font size

   GetTextMetrics( lppw_dlt->hDCTerminal, &tm);
   rgInstData[i].lpEmData->pxFontHeight   = tm.tmHeight;
   rgInstData[i].lpEmData->pxFontWidth    = tm.tmMaxCharWidth;

   // Use the size of the font and the passed in rectangle size and the internally
   //    known current position of the cursor on the screen to determine
   //    the range and position of the scrollbar, and return those values.

   if (lp->SB_type == SB_HORZ)
   {
      int   ctColsAvail = (lp->rectAvail.right - lp->rectAvail.left) / rgInstData[i].lpEmData->pxFontWidth;
      int   ctColsUnavail;

      ctColsAvail = min( NUMCOLS, ctColsAvail);
      ctColsUnavail = NUMCOLS - ctColsAvail;

      iMin = 0;
      iMax = ctColsUnavail;
      iPos = min( ctColsUnavail, rgInstData[i].lpEmData->colLeft);
   }                                   // End of horizontal case
   else                                // Do vertical case
   {
      int   ctRowsAvail = (lp->rectAvail.bottom - lp->rectAvail.top) / rgInstData[i].lpEmData->pxFontHeight;
      int   ctRowsUnavail;

      ctRowsAvail = min( NUMROWS, ctRowsAvail);
      ctRowsUnavail = NUMROWS - ctRowsAvail;

      iMin = 0;
      iMax = ctRowsUnavail;
      iPos = min( ctRowsUnavail, rgInstData[i].lpEmData->rowTop);
   }                                   // End of vertical case


   //
   // Setup return values.
   //
   lp->iMin = iMin;
   lp->iMax = iMax;
   lp->iPos = iPos;

   lp->iFontWidth    = tm.tmMaxCharWidth; // Width (in pixels) of a character cell
   lp->iFontHeight   = tm.tmHeight;    // Height (in pixels) of a character cell
   lp->wRows         = NUMROWS;        // Number of rows the .DLT requests
   lp->wColumns      = NUMCOLS;        // Number of columns the .DLT requests

   return TRUE;
   #undef   lp
}                                      // End of ComputeScrollRange


int   NEAR  PASCAL   SetupFinalSize
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lp points to nothing, lppw_dlt points to the appropriate pw_dlt
   // Function:Setup internal state to match the new window size and
   //             scrollbar ranges.
   // Return:  Return TRUE if successful, FALSE if not.

   int      i;                         // Array index
   int      iPosX, iMinX, iMaxX;       // Horizontal scrollbar position and range
   int      iPosY, iMinY, iMaxY;       // Vertical scrollbar position and range
   RECT     rectAvail;                 // Terminal window size
   LPEMDATA lp;                        // Temporary
   HWND     hWndHorzSB, hWndVertSB;    // Temporaries

   if (!lppw_dlt)                      // Error check
      return FALSE;
   i  =  lppw_dlt->iDLLMagicIndex;
   lp =  rgInstData[i].lpEmData;
   hWndHorzSB  =  *lppw_dlt->lphWndHorzSB;
   hWndVertSB  =  *lppw_dlt->lphWndVertSB;


   // The size of the terminal window is available from GetClientRect.
   GetClientRect( lppw_dlt->hWndTerminal, &rectAvail);

   // The position and range of the scrollbar are available from
   //    the scrollbar handles.

   if (hWndVertSB)                     // If vertical scrollbar exists, get its parameters
   {
      iPosY = GetScrollPos( hWndVertSB, SB_CTL);
      GetScrollRange( hWndVertSB, SB_CTL, &iMinY, &iMaxY);
   }
   else                                // No vertical scrollbar
   {
      iPosY = iMinY = iMaxY = 0;
   }

   if (hWndHorzSB)                     // If horizontal scrollbar exists, get its parameters
   {
      iPosX = GetScrollPos( hWndHorzSB, SB_CTL);
      GetScrollRange( hWndHorzSB, SB_CTL, &iMinX, &iMaxX);
   }
   else                                // No vertical scrollbar
   {
      iPosX = iMinX = iMaxX = 0;
   }

   // Setup the internal state.

   lp->ctColsViewable   =  (rectAvail.right - rectAvail.left) / rgInstData[i].lpEmData->pxFontWidth;
   lp->ctRowsViewable   =  (rectAvail.bottom - rectAvail.top) / rgInstData[i].lpEmData->pxFontHeight;
   lp->colLeft          =  iPosX;
   lp->rowTop           =  iPosY;

   if (lppw_dlt->lpntts->cursor_in_view)
      ScrollToCursorWorker( lppw_dlt);

   return TRUE;
}                                      // End of SetupFinalSize


int   NEAR  PASCAL   SetupCaret
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lp points to nothing, lppw_dlt points to the appropriate pw_dlt
   // Function:Setup internal state to match the new window size and
   //             scrollbar ranges.
   // Return:  Return TRUE if successful, FALSE if not.

   if (!lppw_dlt)                      // Error check
      return FALSE;

   if (*lppw_dlt->lpTerminalHasCaret)  // Setup the caret for the terminal window
      SetupCaretWorker( lppw_dlt->iDLLMagicIndex);

   return TRUE;
}                                      // End of SetupCaret


int   NEAR  PASCAL   RemoveCaret
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lp points to nothing, lppw_dlt points to the appropriate pw_dlt
   // Function:Setup internal state to match the new window size and
   //             scrollbar ranges.
   // Return:  Return TRUE if successful, FALSE if not.

   if (!lppw_dlt)                      // Error check
      return FALSE;

   if (*lppw_dlt->lpTerminalHasCaret)
      RemoveCaretWorker( lppw_dlt);

   return TRUE;
}                                      // End of RemoveCaret


int   NEAR  PASCAL   QueryEscape
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lp points to EscapeStruct, lppw_dlt points to the appropriate pw_dlt
   // Function:Return information about possible DLT Escape functions
   // Return:  Return TRUE if successful, FALSE if not.

   #define  lp ((lpEscapeStruct)lpvoid)

   if (!lp || !lppw_dlt)               // Error check
      return FALSE;
   lp->wSize = sizeof(EscapeStruct);

   switch( lp->nAction)                // See XDLT.H structure definition for
   {                                   //    description of values for lp->nAction
      default:
         lp->nReturnedValue = 0;
   }                                   // End of switch

   return TRUE;
   #undef   lp
}                                      // End of QueryEscape


int   NEAR  PASCAL   PerformEscape
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lp points to EscapeStruct, lppw_dlt points to the appropriate pw_dlt
   // Function:Perform an Escape function
   // Return:  Return TRUE if successful, FALSE if not.

   #define  lp ((lpEscapeStruct)lpvoid)

   if (!lp || !lppw_dlt)               // Error check
      return FALSE;
   lp->wSize = sizeof(EscapeStruct);

   switch( lp->nAction)                // See XDLT.H structure definition for
   {                                   //    description of values for lp->nAction
      default:
         lp->nReturnedValue = 0;
   }                                   // End of switch

   return TRUE;
   #undef   lp
}                                      // End of QueryEscape


int   NEAR  PASCAL   QueryString
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lp points to QueryStringStruct, lppw_dlt points to the appropriate pw_dlt
   // Function:Return an appropriate string.
   // Return:  Return TRUE if successful, FALSE if not.

   static   BYTE  szBmp[] = "BMP";
   static   BYTE  szTxt[] = "TXT";
            BYTE  szBuf[20];

   #define  lp ((lpQueryStringStruct)lpvoid)

   if (!lp || !lppw_dlt)               // Error check
      return FALSE;
   lp->wSize = sizeof(QueryStringStruct);

   //
   // ALWAYS return from the switch.  No cases may fall through.
   //

   switch( lp->nItem)                  // See XDLT.H structure definition for
   {                                   //    description of values for lp->nItem
      case  1:
         // Decide which filetype to use based on current emulation.
         //   We will use BMP for testing purposes.
         lstrcpy( szBuf, szBmp);

         if (lp->lpDest && lp->lenDest)      // Error test
         {
            _fmemcpy( lp->lpDest, szBuf, min(lp->lenDest, lstrlen(szBuf)));
            lp->lpDest[lp->lenDest-1] = 0;   // Null terminate, for sure
            return TRUE;
         }
         else
            return FALSE;

      default:
         return FALSE;
   }                                   // End of switch

   #undef   lp
}                                      // End of QueryString


int   NEAR  PASCAL   TerminalChanged
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lp points to nothing
   // Function:Noification that the TerminalNamedTable has been changed
   // Return:  Return TRUE if successful, FALSE if not.

   return TRUE;
}                                      // End of TerminalChanged


int   NEAR  PASCAL   MenuNotification
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lp points to MenuNotificationStruct, lppw_dlt points to the appropriate pw_dlt
   // Function:Handle a WM_COMMAND message, if desired.
   // Return:  Return TRUE if message handled, FALSE if not.

   #define  lp ((lpMenuNotificationStruct)lpvoid)

   // if lp->wParam == ID_PASTE and you want to handle PASTE, then
   //    handle PASTE and then return TRUE.
   // Return FALSE if not handled.

   return FALSE;

   #undef   lp
}                                      // End of TerminalChanged



int   NEAR  PASCAL   SpecialKeys
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lp points to SpecialKeysStruct, lppw_dlt points to the appropriate pw_dlt
   // Function:Notification for handling keyboard mapped string transmission (pre-parse if terminal requires)
   // Return:  Return TRUE if message handled, FALSE if not.

   #define  lp ((lpSpecialKeysStruct)lpvoid)

   return   FALSE;

   #undef   lp
}

int   NEAR  PASCAL   QueryRowColInfo
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lp points to QueryRowColInfoStruct, lppw_dlt points to the appropriate pw_dlt
   // Function:Request for various info about terminal ROW/COL data.  See QueryRowColInfoStruct
   //          for details.
   // Return:  Return TRUE if message handled, FALSE if not.

   #define  lp ((lpQueryRowColInfoStruct)lpvoid)

   return   FALSE;

   #undef   lp
}

int   NEAR  PASCAL   TerminalPollExt
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lp points to TerminalPollExtStruct, lppw_dlt points to the appropriate pw_dlt
   // Function:Retrieve incoming data from PW recieve buffer.
   // Return:  Return TRUE if message handled, FALSE if not.

   #define  lp ((lpTerminalPollExtStruct)lpvoid)

   // Called off of the timer every 55 msec while PW is in terminal mode.
   // Characters can be freely read from and written to the commports
   //    during this time.  This is the normal wakeup point for periodic
   //    terminal processing.  However, while PW is doing other things, eg
   //    a file transfer or running a script which overrides the terminal
   //    this entry will not be called.  If there is background maintenance
   //    which MUST be performed even though no characters may be read from
   //    or written to the comm ports, then that should be put in DLT_Timer--
   //    see the information there.
   // If the DLT_Timer entry is enabled, then DLT_Timer and DLT_TerminalPollExt
   //    will be called in succession in the same time-slice.
   // No dialogs or MessageBoxes may be displayed during this call.  Doing so
   //    will compromise the integrity of PW.
   // Loop until timer kicks over or no data left, reading processing
   //    data

   int         i;                      // rgInstData index
   BYTE        ch;                     // Character to process
   COMSTAT     ComStat;                // Receive area for GetCommError

   if (!lppw_dlt)
      return FALSE;
   lp->wSize = sizeof(TerminalPollExtStruct);
   i  = lppw_dlt->iDLLMagicIndex;

   /*
   
     Check for click and drag active.  If so, then do not process any
        terminal characters.
   
   */
   if (rgInstData[i].lpEmData->f.LMouseClicked)
      return FALSE;

   /*
   
     Check for Comm Characters.  Load ComStat.cbInQue with number of
        comm chars outstanding.
   
   */


   if (*lppw_dlt->lphCid != (COMM_HANDLE)(-1))
      ((T_GetCommErrorX)lppw_dlt->lpcbs->GetCommErrorX)( *lppw_dlt->lphCid, &ComStat);
   else
      ComStat.cbInQue = 0;

   /*
   
     Handle queued up characters.
   
   */
   if (  !P_GRXQueueEmpty() ||                     // If there is something in the queue
         rgInstData[i].lpEmData->f.ReplayingFile   //     or something to play back ...
      )
   {
      //
      // There is data coming in, so reset the timeout value.
      //
      rgInstData[i].lpEmData->ctTicksNoRXData = 0;

      //
      // If the terminal owns the caret, hide it.
      //
      if(*lppw_dlt->lpTerminalHasCaret)
         RemoveCaretWorker( lppw_dlt);

      //
      // Loop for each character.
      //
      do                               // Once per character processed.
      {
         //
         // Read a character and exit loop if none.  Go ahead and process the
         //    character even if there was an error.
         //
         if (!P_GRXGet( &ch, NULL, 1))
            break;

         /*
         
           Do terminal emulation.
         
         */

         ProcessAChar( i, ch);

      }  while (GetCurrentTime() < lp->dwmsEnd);

      //
      // Restore caret removed above.
      //
      if(*lppw_dlt->lpTerminalHasCaret)
         SetupCaretWorker( i);

   }                                   // End of if (something in the queue)
   else
      rgInstData[i].lpEmData->ctTicksNoRXData++;

   /*
   
     Implement delayed bringing of viewport to cursor. 
   
   */
   if (  rgInstData[i].lpEmData->ctTicksNoRXData == 4 // one-fourth second of silence
         && lppw_dlt->lpntts->cursor_in_view          //    and user requested keeping cursor in view
      )
   {
      if(*lppw_dlt->lpTerminalHasCaret)               // Because scrolling will occur
         RemoveCaretWorker( lppw_dlt);             //    hide the caret

      ScrollToCursorWorker( lppw_dlt);             // Perform the scrolling

      if(*lppw_dlt->lpTerminalHasCaret)               // After scrolling, reshow
         SetupCaretWorker( i);                        //    the caret
   }

   return TRUE;

   #undef   lp
}

int   NEAR  PASCAL   SnapShot_Mail
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lp points to SnapShot_MailStruct, lppw_dlt points to the appropriate pw_dlt
   // Function:Request to send a SnapShot of the terminal screen to mail (using MAPI)
   // Return:  Return TRUE if message handled, FALSE if not.

   #define  lp ((lpSnapShot_Mail)lpvoid)

   return   FALSE;

   #undef   lp
}

int   NEAR  PASCAL   SnapShot_Capture
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lp points to SnapShot_CaptureStruct, lppw_dlt points to the appropriate pw_dlt
   // Function:Request from PW to send current terminal screen to active capture file.
   // Return:  Return TRUE if message handled, FALSE if not.

   #define  lp ((lpSnapShot_CaptureStruct)lpvoid)

   return   FALSE;

   #undef   lp
}

int   NEAR  PASCAL   SnapShot_Fax
(
   LPVOID   lpvoid,
   LPPW_DLT lppw_dlt
)
{
   // Input:   lp points to SnapShot_FaxStruct, lppw_dlt points to the appropriate pw_dlt
   // Function:Request from PW for terminal to send screen contents to fax image.  The
   //          SnapShot_FaxStruct structure will contain a valid HDC (printer DC) to be
   //          used for printing the terminal display.
   // Return:  Return TRUE if message handled, FALSE if not.

   #define  lp ((lpSnapShot_FaxStruct)lpvoid)

   return   FALSE;

   #undef   lp
}


/*

                                                                    
                 Main terminal window procedure                     
                                                                    

*/

LONG  EXPORTED FAR   PASCAL   DLTTerminalWinProc
(
   HWND        hWnd,                   //  Intended window
   UINT        uiMsgId,                //  Message Number
   WPARAM      wParam,                 //  16 bit param
   LPARAM      lParam                  //  32 bit param
)
{
   switch (uiMsgId)
   {
      case WM_RBUTTONDBLCLK:
         // Send cursor sequences to cursor to the clicked position
         break;

      case WM_LBUTTONDBLCLK:
         // Parse outwards from the current position to whitespace on either
         //    side of the current position and put that text out the
         //    comm port or to the PW clipboard or to Windows the clipboard. (TBD)
         break;

      case WM_LBUTTONDOWN:
      {
         //
         // Setup.
         //
         LPPW_DLT lppw_dlt;
         int      i = GetInstanceDataIndexFromhWnd( hWnd);
         if (i == -1)                  // Error condition
            break;

         //
         // Force the focus to PW if it is not already there.
         //
         lppw_dlt = rgInstData[i].lppw_dlt;
         if(GetFocus() != lppw_dlt->hWndMain)
         {
            SetFocus( lppw_dlt->hWndMain);
         }
         //
         // Start up a selection if the focus is already on the window.
         //
         else
         {
            // Assert that the emulation is in a click-and-drag situation.
            rgInstData[i].lpEmData->f.LMouseClicked = TRUE;
            // NEEDS CODE!
         }
         break;
      }                                // End of case WM_LBUTTONDOWN

      case WM_MOUSEMOVE:
      {
         // Highlight the new selection, if the left button is down.

         //
         // Setup.
         //
         int i = GetInstanceDataIndexFromhWnd( hWnd);
         if (i == -1)                  // Error condition
            break;

         //
         // Invert the selected area of the emulation screen.  Be sure to handle
         //    movement of the mouse and areas that are not in the viewport.
         //
         if (rgInstData[i].lpEmData->f.LMouseClicked)
         {
            // NEEDS CODE!
         }
         break;
      }                                // End of case WM_MOUSEMOVE

      case WM_LBUTTONUP:
      {
         // Release the current selection.

         //
         // Setup.
         //
         int i = GetInstanceDataIndexFromhWnd( hWnd);
         if (i == -1)                  // Error condition
            break;

         //
         // Deselect any selected area of the emulation screen.
         //
         rgInstData[i].lpEmData->f.LMouseClicked = FALSE;
         // NEEDS CODE!
         break;
      }                                // End of case WM_MOUSEMOVE

      case WM_RBUTTONDOWN:
         // If the left button is currently down and there is a current selection,
         //    then send the selection out the commport, to the PW clipboard, or
         //    to the Windows clipboard. (To be fully determined later)
         //
         // For now, send it out the commport with pacing active, and also to the
         //    Windows clipboard.
         break;

      case  WM_HSCROLL:
         {
            int   i, Code, Position;
            HWND  WMHwnd;
            i = GetInstanceDataIndexFromhWnd( hWnd);
            if (i == -1)               // Error condition, should never happen
               break;
            ParseWM_HSCROLL( WMHwnd, Code, Position, wParam, lParam);
            TerminalHSCROLL( i, Code, Position);
         }
         break;

      case  WM_VSCROLL:
         {
            int   i, Code, Position;
            HWND  WMHwnd;
            i = GetInstanceDataIndexFromhWnd( hWnd);
            if (i == -1)               // Error condition, should never happen
               break;
            ParseWM_VSCROLL( WMHwnd, Code, Position, wParam, lParam);
            TerminalVSCROLL( i, Code, Position);
         }
         break;

      case WM_PAINT:
      {
         int         i;                   // index into instance array
         PAINTSTRUCT ps;
         HDC         hDC;
         RECT        rPaint;              // Read/Write copy of ps.rcPaint
         RECT        rRowCol;             // Data array coordinates for paint rectangle,
                                          //    except, .right and .bottom are COUNTS of
                                          //    columns and rows, respectively, instead
                                          //    of the number of the rightmost column and
                                          //    bottommost row.

         i = GetInstanceDataIndexFromhWnd( hWnd);
         if (i == -1)                     // Error condition, should never happen
            break;
         hDC = BeginPaint( hWnd, &ps);    // hDC should be  lppw_dlt->hDCTerminal!
                                          // hDC already has correct font from DLT_Startup() call
         CopyRect( &rPaint, &ps.rcPaint); // Make a writable copy of paint rectangle
                                          // Compute top/left corner and number of rows and columns to be painted
         ComputeRowColAndPaintRect( i, &rPaint, &rRowCol);
         while (rRowCol.bottom--)         // Loop once per row
         {
            TextOut( hDC, rPaint.left, rPaint.top, &rgInstData[i].lpEmData->rgbyChars[rRowCol.top][rRowCol.left], rRowCol.right);
            rPaint.top += rgInstData[i].lpEmData->pxFontHeight;
            rRowCol.top++;
         }                                // End of while
         EndPaint(hWnd, &ps);
         break;
      }                                   // End of WM_PAINT

      default:
         return(DefWindowProc(hWnd, uiMsgId, wParam, lParam));
   }                                      // End switch uiMsgId

   return( 0L);
}                                         // DLTTerminalWinProc

/*

۰
۰                       
۰  Internal routines    
۰                       
۰

*/

//
// Find the instance data array element given only the window handle.
//
int   NEAR  PASCAL   GetInstanceDataIndexFromhWnd
(
   HWND  hWnd
)
{
   int   i;

   for(  i=0; i<NumElements(rgInstData); i++)
   {
      if (rgInstData[i].hWndTerminal == hWnd)
         return i;
   }

   return -1;
}                                      // End of GetInstanceDataIndexFromhWnd


//
// Find the lppw_dlt given only the window handle.
//
LPPW_DLT NEAR  PASCAL   GetPW_DLTFromhWnd
(
   HWND  hWnd
)
{
   int i = GetInstanceDataIndexFromhWnd( hWnd);
   if (i==-1)
      return NULL;
   else
      return rgInstData[i].lppw_dlt;
}                                      // End of GetPW_DLTFromhWnd


//
//  Compute the row and column in the screen which correspond to the
//    upper left of the paint rectangle, and also the NUMBER of rows
//    and columns included in the paint rectangle.
//
void     NEAR  PASCAL   ComputeRowColAndPaintRect
(
   int      i,                         // InstanceData index
   LPRECT   nprcPaint,                 // Input, and returned truncated to whole character cell boundaries
   LPRECT   nprcRowCol                 // Returned logical buffer row/col and height/width
)
{
   int      iFontHeight, iFontWidth;   // Temporaries to reduce access overhead
   int      pxX, pxY;                  // Temporaries to reduce access overhead
   int      offCols, offRows;          // Number of columns and rows into the viewport
                                       //    that the paint rectangle starts

   iFontHeight             =  rgInstData[i].lpEmData->pxFontHeight;
   iFontWidth              =  rgInstData[i].lpEmData->pxFontWidth;

   offRows                 =  nprcPaint->top  / iFontHeight;
   offCols                 =  nprcPaint->left / iFontWidth;

   pxY = nprcPaint->top    =  offRows * iFontHeight;
   pxX = nprcPaint->left   =  offCols * iFontWidth;

   nprcRowCol->top         =  offRows + rgInstData[i].lpEmData->rowTop;
   nprcRowCol->left        =  offCols + rgInstData[i].lpEmData->colLeft;

                                       // Compute rows and columns IN the rectangle
   nprcRowCol->bottom      =  (nprcPaint->bottom - pxY + iFontHeight - 1) / iFontHeight;
   nprcRowCol->right       =  (nprcPaint->right - pxX + iFontWidth - 1) / iFontWidth;

}                                      // End of ComputeRowColAndPaintRect


//
// Generic single character parser.  Handle any single character.  Of
//    course, for a real emulation it would have internal state.  It is
//    included here for demonstration primarily of the proper time
//    to call P_RecordModeChange().
//
void     NEAR  PASCAL   ProcessAChar
(
   int      i,                         // rgInstData index
   BYTE     ch                         // Character to process
)
{
   LPPW_DLT lppw_dlt = rgInstData[i].lppw_dlt;
   LPEMDATA lpEmData = rgInstData[i].lpEmData;

   if (lpEmData->hCaptureFile)            // Capture data, if needed
      ((T_flputc)lppw_dlt->lpcbs->flputc)( (int)ch, lpEmData->hCaptureFile);

   switch( ch)
   {
      case  13:                        // Carriage Return.  Note use of P_RecordModeChange().
         lpEmData->colCur = 0;         //    P_RecordModeChange would also be used when
                                       //    processing TAB or ABSOLUTE CURSOR ADDRESS.
         if (*lppw_dlt->lphRecordFile != INVALID_HANDLE_VALUE)
            ((T_RecordModeChange)lppw_dlt->lpcbs->RecordModeChange)();
         break;
      case  10:                        // Line Feed.  Note use of P_RecordModeChange().
         lpEmData->rowCur++;
         if (lpEmData->rowCur >= NUMROWS)
            lpEmData->rowCur = 0;
         if (*lppw_dlt->lphRecordFile != INVALID_HANDLE_VALUE)
            ((T_RecordModeChange)lppw_dlt->lpcbs->RecordModeChange)();
         break;
      default:
         ProcessANormalChar( i, ch);
         break;
   }                                   // End of switch
}                                      // End of ProcessAChar


//
// Place a single normal character (not a control character or ESCAPE
//    sequence) into the current position in the buffer and paint it.
//
void     NEAR  PASCAL   ProcessANormalChar
(
   int   i,                            // rgInstData index
   BYTE  ch                            // Character to process
)
{
   int   rowCur = rgInstData[i].lpEmData->rowCur;           // Temporaries
   int   colCur = rgInstData[i].lpEmData->colCur;
   int   rowOff = rowCur - rgInstData[i].lpEmData->rowTop;  // Offsets into viewport
   int   colOff = colCur - rgInstData[i].lpEmData->colLeft;

   //
   // Store the new character in the screen buffer.
   //
   rgInstData[i].lpEmData->rgbyChars[rowCur][colCur] = ch;

   //
   // Paint the new character.
   //
   if (rowOff >= 0 && colOff >= 0)     // Paint only if char in viewport
   {
      TextOut( rgInstData[i].lppw_dlt->hDCTerminal,
               colOff * rgInstData[i].lpEmData->pxFontWidth,
               rowOff * rgInstData[i].lpEmData->pxFontHeight,
               &ch, 1);
   }

   //
   // Move to next position.
   //
   colCur++;
   if (colCur >= NUMCOLS)              // Handle wrapping at end-of-line
   {
      colCur = 0;
      rowCur++;
      if (rowCur >= NUMROWS)           // Handle wrapping at end-of-screen
         rowCur = 0;                   // Row can only change during wrapping
      rgInstData[i].lpEmData->rowCur = rowCur;
   }
   rgInstData[i].lpEmData->colCur = colCur;

}                                      // End of ProcessANormalChar


//
// Only called if the terminal owns the caret, that is, if
//    (*lppw_dlt->lpTerminalHasCaret) is true.  It sets the position
//    and size of the caret.  It could done more cleanly, but it is
//    difficult to coordinate without a focus-changing message, which
//    the terminal window never gets.  This technique is used in PW,
//    and does not appear to be a significant CPU consumer.
//
void  NEAR  PASCAL   SetupCaretWorker
(
   int   i                             // rgInstData index
)
{
   LPEMDATA lp = rgInstData[i].lpEmData;// Temporary

   CreateCaret(   rgInstData[i].lppw_dlt->hWndTerminal, NULL, lp->pxFontWidth, lp->pxFontHeight);
   SetCaretPos(   (lp->colCur - lp->colLeft) * lp->pxFontWidth,
                  (lp->rowCur - lp->rowTop ) * lp->pxFontHeight);
   ShowCaret(     rgInstData[i].lppw_dlt->hWndTerminal);
}                                      // End of SetupCaretWorker


//
// Only called if the terminal owns the caret, that is, if
//    (*lppw_dlt->lpTerminalHasCaret) is true.  It removes the caret
//    from the terminal window.
//
void  NEAR  PASCAL   RemoveCaretWorker
(
   LPPW_DLT lppw_dlt
)
{
   HideCaret( lppw_dlt->hWndTerminal);
}                                      // End of RemoveCaretWorker


//
// Handle the vertical scroll messages.
//
void  NEAR  PASCAL   TerminalVSCROLL
(
   int   i,                            // rgInstData index
   int   Code,                         // SB_*
   int   Position                      // Scroll Position, if defined
)
{
   int      nScroll, sbposNew, sbposCur, sbposMin, sbposMax;
   BOOL     fHandleCaret;              // Temporary
   HWND     hWndTerm;                  // Temporary handle to terminal window
   HWND     hWndSB;                    // Temporary handle to scrollbar window
   LPPW_DLT lppw_dlt;                  // Temporary
   LPEMDATA lpEmData;                  // Temporary

   if (Code == SB_ENDSCROLL)           // Don't need to process this one at ALL
      return;

   lppw_dlt       = rgInstData[i].lppw_dlt;
   lpEmData       = rgInstData[i].lpEmData;
   hWndTerm       = lppw_dlt->hWndTerminal;
   hWndSB         = *lppw_dlt->lphWndVertSB;
   fHandleCaret   = *lppw_dlt->lpTerminalHasCaret;

   if (fHandleCaret)
      RemoveCaretWorker( lppw_dlt);

   sbposNew = sbposCur = GetScrollPos( hWndSB, SB_CTL);
   GetScrollRange( hWndSB, SB_CTL, &sbposMin, &sbposMax);

   switch(Code)
   {
      case  SB_LINEUP:
         if (sbposCur > sbposMin)      // If can go up, do
            sbposNew = sbposCur - 1;
         break;

      case  SB_LINEDOWN:
         if (sbposCur < sbposMax)      // If can go down, do
            sbposNew = sbposCur + 1;
         break;

      case  SB_PAGEUP:
      {
         int   sbposDelta =            // The maximum amount can scroll up
                  min(  (UINT)lpEmData->ctRowsViewable,  // Viewport size
                        (UINT)(sbposCur - sbposMin)      // Distance to top of buffer
                     );                // sbposDelta is > 0 because both operands are > 0
         sbposNew = sbposCur - sbposDelta;
         break;
      }

      case  SB_PAGEDOWN:
      {
         int   sbposDelta =            // The maximum amount can scroll down
                  min(  (UINT)lpEmData->ctRowsViewable,  // Viewport size
                        (UINT)(sbposMax - sbposCur)      // Distance to top of buffer
                     );                // sbposDelta is > 0 because both operands are > 0
         sbposNew = sbposCur + sbposDelta;
         break;
      }

      case  SB_TOP:
         sbposNew = sbposMin;
         break;

      case  SB_BOTTOM:
         sbposNew = sbposMax;
         break;

      case  SB_THUMBTRACK:
      case  SB_THUMBPOSITION:
         sbposNew = Position;
         break;
   }                                   // End of switch (Code)

   //
   // Only scroll if there is actually something to do.
   //

   nScroll = sbposCur - sbposNew;
   if (nScroll)
   {
      lpEmData->rowTop = sbposNew;
      SetScrollPos( hWndSB, SB_CTL, sbposNew, TRUE);
      ScrollWindow( hWndTerm, 0, nScroll * lpEmData->pxFontHeight, NULL, NULL);
      UpdateWindow( hWndTerm);
   }

   if (fHandleCaret)
      SetupCaretWorker( i);
}                                      // End of TerminalVSCROLL


//
// Handle the horizontal scroll messages.
//
void  NEAR  PASCAL   TerminalHSCROLL
(
   int   i,                            // rgInstData index
   int   Code,                         // SB_*
   int   Position                      // Scroll Position, if defined
)
{
   int      nScroll, sbposNew, sbposCur, sbposMin, sbposMax;
   BOOL     fHandleCaret;              // Temporary
   HWND     hWndTerm;                  // Temporary handle to terminal window
   HWND     hWndSB;                    // Temporary handle to scrollbar window
   LPPW_DLT lppw_dlt;                  // Temporary
   LPEMDATA lpEmData;                  // Temporary

   if (Code == SB_ENDSCROLL)           // Don't need to process this one at ALL
      return;

   lppw_dlt       = rgInstData[i].lppw_dlt;
   lpEmData       = rgInstData[i].lpEmData;
   hWndTerm       = lppw_dlt->hWndTerminal;
   hWndSB         = *lppw_dlt->lphWndHorzSB;
   fHandleCaret   = *lppw_dlt->lpTerminalHasCaret;

   if (fHandleCaret)
      RemoveCaretWorker( lppw_dlt);

   sbposNew = sbposCur = GetScrollPos( hWndSB, SB_CTL);
   GetScrollRange( hWndSB, SB_CTL, &sbposMin, &sbposMax);

   switch(Code)
   {
      case  SB_LINEUP:
         if (sbposCur > sbposMin)      // If can go up, do
            sbposNew = sbposCur - 1;
         break;

      case  SB_LINEDOWN:
         if (sbposCur < sbposMax)      // If can go down, do
            sbposNew = sbposCur + 1;
         break;

      case  SB_PAGEUP:
      {
         int   sbposDelta =            // The maximum amount can scroll up
                  min(  (UINT)lpEmData->ctColsViewable,  // Viewport size
                        (UINT)(sbposCur - sbposMin)      // Distance to top of buffer
                     );                // sbposDelta is > 0 because both operands are > 0
         sbposNew = sbposCur - sbposDelta;
         break;
      }

      case  SB_PAGEDOWN:
      {
         int   sbposDelta =            // The maximum amount can scroll down
                  min(  (UINT)lpEmData->ctColsViewable,  // Viewport size
                        (UINT)(sbposMax - sbposCur)      // Distance to top of buffer
                     );                // sbposDelta is > 0 because both operands are > 0
         sbposNew = sbposCur + sbposDelta;
         break;
      }

      case  SB_TOP:
         sbposNew = sbposMin;
         break;

      case  SB_BOTTOM:
         sbposNew = sbposMax;
         break;

      case  SB_THUMBTRACK:
      case  SB_THUMBPOSITION:
         sbposNew = Position;
         break;
   }                                   // End of switch (Code)

   //
   // Only scroll if there is actually something to do.
   //

   nScroll = sbposCur - sbposNew;
   if (nScroll)
   {
      lpEmData->colLeft = sbposNew;
      SetScrollPos( hWndSB, SB_CTL, sbposNew, TRUE);
      ScrollWindow( hWndTerm, nScroll * lpEmData->pxFontWidth, 0, NULL, NULL);
      UpdateWindow( hWndTerm);
   }

   if (fHandleCaret)
      SetupCaretWorker( i);
}                                      // End of TerminalHSCROLL


//
// Dump the current screen contents to the DC at the given position
//    in the current font.  Returns the new vertical position on the
//    page at the end of the dump.
//
int NEAR PASCAL DumpScreenToPrinter
(
   int   i,                            // Current instance data index
   HDC   hDC,                          // DC to write to
   int   x,                            // Starting position
   int   y,                            // Starting position
   int   LineHeight                    // Height of the current font
)
{
   int   n;                            // Loop counter

   for(  n=0; n<NUMROWS; n++)
   {
      TextOut( hDC, x, y, &rgInstData[i].lpEmData->rgbyChars[n][0], NUMCOLS);
      y += LineHeight;
   }                                   // End of for

   return y;
}


BOOL EXPORTED FAR PASCAL AdvSetupDlgProc
(
   HWND     hDlg,
   UINT     message,
   WPARAM   wParam,
   LPARAM   lParam
)
{
   int         Id;                     // Variables for message crackers
   int         Cmd;
   HWND        WMHwnd;

   int         i;                      // rgInstData array index
   lpDoAdvancedSetupDialogStruct lpAdv;// Pointer to AdvancedSetup struct
   VTX_OPTIONS FAR*  lp;               // local pointer to lpAdv->lpExtraBytes
   static char szUnique1[]="a";        // Unique string for property list
   static char szUnique2[]="b";        // Unique string for property list

   switch (message)
   {
      case  WM_INITDIALOG:             // lParam is lppw_dlt
         // Save the pointer passed in the lParam on a per instance basis
         lpAdv = (lpDoAdvancedSetupDialogStruct)lParam;
         SetProp( hDlg, szUnique1, (HANDLE)LOWORD(lpAdv));
         SetProp( hDlg, szUnique2, (HANDLE)HIWORD(lpAdv));

         // Initialize the controls
         lp = lpAdv->lpExtraBytes;

         // Initialize the controls
         CheckDlgButton( hDlg, 20, lp->no_attributes);   // Set disable attributes
         CheckDlgButton( hDlg, 21, lp->unhide);       // Set unhide
         CheckDlgButton( hDlg, lp->Prestel_Character_Set + 30, TRUE);   // Set character set
         CheckDlgButton( hDlg, (int)lp->print_bitmap + 60, TRUE); // Set bitmap-text
         CheckDlgButton( hDlg, lp->capture_type + 70, TRUE);   // Set bitmap-text
         return(TRUE);

      case  WM_DESTROY:
         RemoveProp( hDlg, szUnique1);
         RemoveProp( hDlg, szUnique2);
         break;

      case  WM_COMMAND:
      {
         ParseWM_COMMAND(WMHwnd, Id, Cmd, wParam, lParam);

         switch (Id)                   // All cases end with return()
         {
            case  IDOK:
               lpAdv = (lpDoAdvancedSetupDialogStruct)MAKELONG( GetProp(hDlg,szUnique1), GetProp(hDlg,szUnique2));
               lp    = (VTX_OPTIONS FAR*)(lpAdv->lpExtraBytes);

               lp->no_attributes = (BYTE)IsDlgButtonChecked( hDlg, 20);
               lp->unhide = (BYTE)IsDlgButtonChecked( hDlg, 21);
               for(i=0;i<8;i++)
                  if(IsDlgButtonChecked( hDlg, 30+i))
                  {
                      lp->Prestel_Character_Set = (BYTE)i;
                      break;
                  }
               lp->print_bitmap = (BYTE)IsDlgButtonChecked( hDlg, 61);
               lp->capture_type = (BYTE)IsDlgButtonChecked( hDlg, 71);
               lpAdv->uExtraUsed = sizeof(VTX_OPTIONS);
               EndDialog( hDlg, TRUE);
               return TRUE;

            case  IDCANCEL:
               EndDialog( hDlg, FALSE);
               return FALSE;

            default:
               return FALSE;
         }
      }                                // End of case WM_COMMAND

      default:
         return FALSE;
   }
   return FALSE;
}                                      // End of AdvSetupDlgProc



//
// Compute whether or not the cursor is within the current viewport.
//    If it is not, scroll to bring the viewport to the cursor.
//    It is assumed that if this is called, the user has set
//    lppw_dlt->lpntts->cursor_in_view and so this routine should
//    go ahead and do it with no further checking.
//
void NEAR PASCAL ScrollToCursorWorker
(
   LPPW_DLT lppw_dlt
)
{
   int      iPos, iMin, iMax;
   int      deltacol, deltarow, n;
   HWND     hWndVertSB, hWndHorzSB;    // Temporary
   LPEMDATA lp = rgInstData[lppw_dlt->iDLLMagicIndex].lpEmData;   // Temporary

                                       // n is the number of columns past the
                                       //    right edge of the viewport at
                                       //    which current column resides.
   n  =  lp->colCur - (lp->colLeft + lp->ctColsViewable - 1);

   if (n > 0)                          // Cursor is to right of viewport, this
      deltacol  =  n;                  //    will be most often special case
   else
   {
      n  =  lp->colCur;                // Current column, decremented if possible
      if (n > 0)                       //    because last char will be one BEFORE
         n--;                          //    current column.
                                       // Then compare against
      n  -= lp->colLeft;               //    viewport to see if need to move.

      if (n < 0)                       // Cursor is to left of viewport
         deltacol =  n;
      else                             // Cursor is in the viewport
         deltacol =  0;
   }

   /*
   
     Compute deltarow in logical terminal coordinates                    
   
   */

   n  =  lp->rowCur - (lp->rowTop + lp->ctRowsViewable - 1);

   if (n > 0)                          // Cursor is below viewport, this
      deltarow =  n;                   //    will be most often special case
   else
   {
      n  =  lp->rowCur - lp->rowTop;

      if (n < 0)                       // Cursor is above viewport
         deltarow =  n;
      else                             // Cursor is in the viewport
         deltarow =  0;
   }

   /*
   
     If a viewport move is required take appropriate action.             
   
   */

   hWndVertSB = *lppw_dlt->lphWndVertSB;

   //
   // Do vertical scroll first.
   //

   if (deltarow && hWndVertSB)
   {
      iPos  =  GetScrollPos( hWndVertSB, SB_CTL);
      GetScrollRange( hWndVertSB, SB_CTL, &iMin, &iMax);

      if ((iPos+deltarow) < iMin)      // Hack for a few special situations where this
         deltarow = iMin - iPos;       //    might happen, such as screen of < 1 whole row
      else if ((iPos+deltarow) > iMax)
         deltarow = iMax - iPos;

      SendWM_VSCROLL( lppw_dlt->hWndTerminal, SB_THUMBPOSITION, iPos+deltarow, 0);
   }

   //
   // Do horizontal scroll.
   //

   hWndHorzSB = *lppw_dlt->lphWndHorzSB;

   if (deltacol && hWndHorzSB)
   {
      iPos  =  GetScrollPos( hWndHorzSB, SB_CTL);
      SendWM_HSCROLL( lppw_dlt->hWndTerminal, SB_THUMBPOSITION, iPos+deltacol, 0);
   }

}                                      // End of ScrollToCursorWorker


