/*
 
                                                                          
                     Copyright (C) 1999 Symantec Corp.                    
                            All Rights Reserved                           
                                                                          
       Information in this file is proprietary and confidential, and      
         may not be copied, reproduced or distributed in any manner       
      without the express written permission of Symantec Corp.            
                                                                          
 
*/

#ifndef __GATHER_H__
#define __GATHER_H__

//
// Bit values for flags
//
#define GRX_CASE        0x01           //Case sensitive
#define GRX_FLUSH       0x02           //Flush to queue if matched
#define GRX_IMMEDIATE   0x04           //Fire immediately
#define GRX_TIMEOUTONLY 0x08           //Fire only on timeout
#define GRX_XLATE       0x10           //Check if stripping & Xlating should happen

//
// Source of the character
//
#define COM_PORT_STREAM          0x01
#define LOCAL_ECHO_STREAM        0x02
#define PLAYBACK_STREAM          0x04  // Warning! do not change this #define
                                       //    unless you update EUROTEL\PWDUE\PW\PHYIO.C
                                       //    which uses a hard-coded version of it!

#define ALL_STREAMS              COM_PORT_STREAM | LOCAL_ECHO_STREAM | PLAYBACK_STREAM

//
// Return value from the matching algorithm
//
#define STRDB_MATCHED            1
#define STRDB_NOMATCH          (-3)

//
// Special value for the matching algorithm
//
#define STRMATCH_DONTCARE        0x01  //don't care character - don't worry if it does not match

#endif
