/*
 
                                                                          
                     Copyright (C) 1999 Symantec Corp.                    
                            All Rights Reserved                           
                                                                          
       Information in this file is proprietary and confidential, and      
         may not be copied, reproduced or distributed in any manner       
      without the express written permission of Symantec Corp.            
                                                                          
 
*/

#ifndef _INC_MENU_IDS
   #define _INC_MENU_IDS

// Definition of first (minimum) PW menu item ID
#define PWMENUBEGIN                    200

// file menu
#ifdef ID_FILE_NEW      // * This is also defined by MFC.
#undef ID_FILE_NEW      // * We must make sure our defines
#endif                  // * are being used.
// This group is associated with helpfile pw45.hlp
#define ID_FILE_NEW                    200

#ifdef ID_FILE_OPEN     // * This is also defined by MFC.
#undef ID_FILE_OPEN     // * We must make sure our defines
#endif                  // * are being used.
#define ID_FILE_OPEN                   201
#define ID_FILE_VIEWDIAL               202
// This group is associated with helpfile terminal.hlp
#define ID_PRINT_SETUP                 203
#define ID_PRINT_CAPTURE               204
#define ID_PLAYBACK                    205
#define ID_CONNECT_LOG                 206
// This group is associated with helpfile pw45.hlp
#define ID_EXIT                        207

// edit menu
// This group is associated with helpfile terminal.hlp
#define ID_COPY_LINK                   208
#define ID_PASTE                       209
#define ID_SEARCH                      210
#define ID_SCREEN_TO_CLIP              211
#define ID_SCREEN_TO_LOG               212
#define ID_SCREEN_TO_FILE              213
#define ID_SCREEN_TO_PRINTER           214
#define ID_SCREEN_TO_BUFF              215
#define ID_SCREEN_TO_FAX               216
#define ID_SCREEN_TO_MAIL              217
#define ID_BUFF_TO_CLIP                218
#define ID_BUFF_TO_LOG                 219
#define ID_BUFF_TO_FILE                220
#define ID_BUFF_TO_PRINTER             221
#define ID_BUFF_TO_FAX                 222
#define ID_BUFF_TO_MAIL                223
#define ID_SCROLLBACK                  224

// setup menu (Note: Changes here must be reflected in PWMenuToSetupArray[] in KEYM_DAT.C)
// This group is associated with helpfile pw45.hlp
#define ID_SETUP                       225

#define ID_SETUP_SYS_SYSOPT            226
#define ID_SETUP_SYS_MODEMCON          227
#define ID_SETUP_SYS_DLOPT             228

#define ID_SETUP_DATA_OPT_GEN          229
#define ID_SETUP_DATA_OPT_ADV          230
#define ID_SETUP_DATA_OPT_LEFTMOUSE    231
#define ID_SETUP_DATA_OPT_RIGHTMOUSE   232
#define ID_SETUP_DATA_OPT_PATHS        233
#define ID_SETUP_DATA_PROTOCOL         234
#define ID_SETUP_DATA_TERMOPT          235
#define ID_SETUP_DATA_TERMFONT         236
#define ID_SETUP_DATA_TERMCOLOR        237
#define ID_SETUP_DATA_WRKSPCCOLOR      238
#define ID_SETUP_DATA_SCRLBARCOLOR     239
#define ID_SETUP_DATA_MONSNDCOLOR      240
#define ID_SETUP_DATA_MONRCVCOLOR      241
#define ID_SETUP_DATA_FILES            242

#define ID_SETUP_FAX_GEN               243
#define ID_SETUP_FAX_INFO              244
#define ID_SETUP_FAX_HEADER            245
#define ID_SETUP_FAX_PATHS             246

#define ID_SETUP_INET_TELNET           247
#define ID_SETUP_INET_TCP_GEN          248
#define ID_SETUP_INET_FTP_GEN          249
#define ID_SETUP_INET_FTP_XFEROPT      250
#define ID_SETUP_INET_FTP_FILEOPT      251
#define ID_SETUP_INET_WWW_GEN          252
#define ID_SETUP_INET_MAIL_INFO        253
#define ID_SETUP_INET_MAIL_SVR         254
#define ID_SETUP_INET_MAIL_INC         255
#define ID_SETUP_INET_MAIL_OUT         256
#define ID_SETUP_INET_MAIL_RPLY        257
#define ID_SETUP_INET_MAIL_OTHR        258
#define ID_SETUP_INET_NEWS_INFO        259
#define ID_SETUP_INET_NEWS_SVR         260
#define ID_SETUP_INET_NEWS_INC         261
#define ID_SETUP_INET_NEWS_RPLY        262
#define ID_SETUP_INET_NEWS_OTHR        263
#define ID_SETUP_INET_NEWS_DBASE       264

#define ID_SETUP_ABAR                  265
#define ID_SETUP_ABAR_ICON_SIZE        266
#define ID_SETUP_LABELS                267
#define ID_SETUP_METAKEYS              268
#define ID_SETUP_QSELECT               269
#define ID_SETUP_STATLINE              270

#define ID_SETUP_ANSWER_OFF            271
#define ID_SETUP_ANSWER_PWANS          272
#define ID_SETUP_ANSWER_OTHANS         273
#define ID_SETUP_ANSWER_DATA           274
#define ID_SETUP_ANSWER_FAX            275

// data menu
// This group is associated with helpfile terminal.hlp
#define ID_DATA_MODEM_ATMODE           276
#define ID_CONNECT_MANUAL              277
#define ID_DATA_ANSWERNOW              278
#define ID_COMM_HANGUP                 279
#define ID_FILE_SEND                   280
#define ID_FILE_RCV                    281
#define ID_KERMIT_GET                  282
#define ID_KERMIT_SEND                 283
#define ID_KERMIT_FINISH               284
#define ID_KERMIT_LOGOUT               285
#define ID_FILE_CAPTURE                286
#define ID_FILECLIP                    287
#define ID_DOORWAY                     288
#define ID_SEND_USERID                 289
#define ID_SEND_PASSWORD               290
#define ID_SEND_MISC                   291
#define ID_CHAT                        292
#define ID_MONITOR                     293
#define ID_COMM_BREAK                  294
#define ID_COMM_SENDXON                295
#define ID_TERM_CLEAR                  296
#define ID_TERM_RESET                  297
#define ID_DATA_DUPLEX_FULL            298
#define ID_DATA_DUPLEX_HALF            299

// scripts menu
// This group is associated with helpfile pw45.hlp
#define ID_SCRIPT_START                300
#define ID_SCRIPT_RUN                  301
#define ID_SCRIPT_EDIT                 302
#define ID_SCRIPT_RECORD               303

// tools menu
// This group is associated with helpfile pw45.hlp
#define ID_RUN_REMOTE                  304
#define ID_SEND_FAX                    305
#define ID_RUN_FAXSTATUS               306
#define ID_RUN_FAXMGR                  307
#define ID_RUN_FAXVIEWER               308
#define ID_RUN_FAXCOVER                309
#define ID_RUN_GIF                     310
#define ID_RUN_SCHEDULER               311
#define ID_RUN_ABAREDIT                312
#define ID_RUN_QWKMAIL                 313
#define ID_RUN_CID_DATABASE            314
#define ID_RUN_PWEDIT                  315
#define ID_RUN_DLGEDIT                 316
#define ID_RUN_USERWIN                 317
#define ID_RUN_META                    318
#define ID_RUN_KBD                     319
#define ID_RUN_XLATE                   320

// window menu
// This group is associated with helpfile pw45.hlp
#define ID_INTERNET_TELNET             321
#define ID_INTERNET_FTP                322
#define ID_INTERNET_WWW                323
#define ID_INTERNET_MAIL               324
#define ID_INTERNET_NEWS               325
#define ID_INTERNET_NEW_TRM            326
#define ID_INTERNET_NEW_TELNET         327
#define ID_INTERNET_NEW_FTP            328
#define ID_INTERNET_NEW_WWW            329
#define ID_INTERNET_NEW_MAIL           330
#define ID_INTERNET_NEW_NEWS           331

// help  menu
// This group is associated with helpfile pw45.hlp
#define ID_HELP_WIZARDS                332
#define ID_HELPCONTENT                 333
#define ID_HELPTERMINAL                334
#define ID_HELPSEARCH                  335
#define ID_HELPKBD                     336
#define ID_SCRIPTREF                   337
#define ID_SCRIPTTOPIC                 338
#define ID_HELPHELP                    339
#define ID_REGISTRATION                340
#define ID_ABOUT                       341
#define ID_LIVEUPDATE                  350
#define ID_ONLINE_REG                  351

// Special case items which map to functions that don't show up as
// individual items in a menu resource. Primarily used as mappable
// entities in actionbar and keyboard editors.
#define PWSPECIALBEGIN                 342

#define ID_CHANGEWINDOW                342
#define ID_NEWWINDOW                   343

#define PWSPECIALEND                   343

#define ID_PWNEXTWIN                   400
#define ID_CYCLEABAR                   401
#define ID_PLAYBACK_PAUSE              402
#define ID_PLAYBACK_RESTART            403
#define ID_RAPIDDIAL                   404
#define ID_RAPIDSCRIPT                 405
#define ID_CTRLBRK                     406

#define ID_SCROLL_BASE                 407
#define ID_SCROLL_LEFT_ONE             (ID_SCROLL_BASE+0)   // 407
#define ID_SCROLL_LEFT_PAGE            (ID_SCROLL_BASE+1)   // 408
#define ID_SCROLL_LEFT_LEFT            (ID_SCROLL_BASE+2)   // 409
#define ID_SCROLL_RIGHT_ONE            (ID_SCROLL_BASE+3)   // 410
#define ID_SCROLL_RIGHT_PAGE           (ID_SCROLL_BASE+4)   // 411
#define ID_SCROLL_RIGHT_RIGHT          (ID_SCROLL_BASE+5)   // 412
#define ID_SCROLL_UP_ONE               (ID_SCROLL_BASE+6)   // 413
#define ID_SCROLL_UP_PAGE              (ID_SCROLL_BASE+7)   // 414
#define ID_SCROLL_UP_TOP               (ID_SCROLL_BASE+8)   // 415
#define ID_SCROLL_DOWN_ONE             (ID_SCROLL_BASE+9)   // 416
#define ID_SCROLL_DOWN_PAGE            (ID_SCROLL_BASE+10)  // 417
#define ID_SCROLL_DOWN_BOTTOM          (ID_SCROLL_BASE+11)  // 418

#define ID_DEBUGBOX                    419

#endif // _INC_MENU_IDS
