/*
 
                                                                          
                     Copyright (C) 1999 Symantec Corp.                    
                            All Rights Reserved                           
                                                                          
       Information in this file is proprietary and confidential, and      
         may not be copied, reproduced or distributed in any manner       
      without the express written permission of Symantec Corp.            
                                                                          
 
*/

#ifndef _INC_PD
   #define _INC_PD

#define ID_ERR             300
#define ID_BLKNO           301
#define ID_PERCENT         302
#define ID_UARTERR         303
#define ID_TIME            304
#define ID_FILENAME        305
#define ID_BPS             306
#define ID_SKIPGIF         400

#define BUTNOTACTIVE        40

#define IDS_LASTERROR     1300
#define IDS_ANSWER          13
#define IDS_NOMODEM         14
#define IDS_DIALING         15
#define IDS_REDIAL          16
#define IDS_BUSY            17
#define IDS_NODIALTONE      18
#define IDS_NOANSWER        20
#define IDS_CODEERROR       21
#define IDS_CONNECT         22
#define IDS_SENDIT          23
#define IDS_RCVIT           24

#define IDS_PROTOMEM        11
#define IDS_BPLUS           12

//
//   WARNING!      WARNING!      WARNING!      WARNING!       WARNING!
//
//   Be careful when changing these states!!!  Any state less than or
//   equal to IDX_TERMINAL will be allowed to send data out using the
//   ADDTOTXBUFF routine.  Greater states will have their output eaten!
//
//   WARNING!      WARNING!      WARNING!      WARNING!       WARNING!
//

#define ASCII_WAITLINE       1
#define ASCII_LDELAY         2
#define ASCII_LCHAR          3
#define ASCII_DONE           4
#define ASCII_RCV            5
#define IDX_DIALING          6
#define IDX_PAUSE            7
#define KER_ACK              8
#define IDX_ASPREM           9
#define BP_BLIND            10
#define IDX_TERMINAL        20
#define IDX_LOSTCARRIER     21
#define IDX_KILLPDLL        22
#define IDX_WAITACK         23
#define IDX_NOCHAR          25
#define IDX_RXING           26
#define IDX_WAITACKG        27
#define BP_SENDDATA         28
#define BP_TRANSPARAM       29
#define BP_FAIL             30
#define BP_RCVFILE          31
#define BP_SENDFILE         32
#define BP_START            33
#define KER_RCV             36
#define KER_A               37
#define KER_C               38
#define KER_E               39
#define ZM_DISPATCH         40
#define IDX_GIF             41
#define IDX_PDLL            42
#define IDX_PKTRCV          43
#define IDX_PKTSEND         44
#define BEEP_AT_END_OF_XFER 45
#define DELAY_BEFORE_HANGUP 46


#define IDP_ACK             50
#define IDP_EOT             51
#define IDP_CHKSUM          52
#define IDP_CRC             53
#define IDP_TERMINATE       54
#define IDP_CANCEL          55

// Some of the special ASCII characters
#define SOH                  1
#define STX                  2
#define ETX                  3
#define EOT                  4
#define ACK                  6
#define LF                  10
#define CR                  13
#define XON                 17
#define XOFF                19
#define NAK                 21
#define CANCEL              24
#define CAN                 24
#define ASCII_RS            30
#define SP                  32
#define DEL                127

#define PW_XMODEM            2
#define PW_XMODEM1K          3
#define PW_XMODEMG           4
#define PW_YMODEM            5
#define PW_YMODEMG           6
#define PW_CISB              7
#define PW_ASCII            20
#define PW_RAWASCII         21
#define PW_KERMIT           22
#define PW_ZMODEM           23
#define PW_DLL              24

// dll protocol capabilities
#define DLL_CAP_SHOWXFER      0x0020
#define DLL_CAP_MULTISEND     0x0002
#define DLL_CAP_AUTODOWNLOAD  0x0001
#define DLL_CAP_PWOPENFILE    0x0004
#define DLL_CAP_RCVNEEDNAME   0x0008
#define DLL_CAP_ADVANCED      0x0080

// --- ProtoCall Dll definition  -------------------------------------------
//
//   WARNING! DON'T CHANGE STRUCT WITHOUT CONSULTING DESIGN SPEC!
//
#ifndef PROTOSET_DEFINED
#define PROTOSET_DEFINED

typedef struct tagPROTOSET
{
   LPSTR dwnload;                      // pointer to download dir
   LPSTR upload;                       // pointer to upload dir
   BYTE FAR *aspfxfer;                 // pointer to aspect file xfer flag

   //
   // These fields are not for general purpose use.
   // They are only valid at certain times for DLL's.
   //
   BYTE should_gif;                    // user wants gif files
   BYTE xfer_dup_new;                  // duplicate new files
   BYTE xfer_del_aborts;               // delete aborts
   BYTE xfer_relaxed;                  // relaxed timing
   //

   LPSTR bigbuff;                      // fixed pointer to first 10240 bytes  of hPBits
   LPSTR bigptr;                       // variable pointer to bigbuf bytes
   LPSTR cbuff;                        // cbuff = bigbuff+10240, fixed pointer to last   1033 bytes of hPBits
   int bdiag;                          // flag set if XFER status dialog box is desired
   HWND hDlg1;                         // handle to XFER status dialog box
   FILE_HANDLE hCommFile;              // handle to open xfer file
   LPSTR fileptr;                      // pointer to file data in hCommFile
   WORD fdate;                         // DOS file date format of hCommFile
   WORD fftime;                        // DOS file time format of hCommFile
   char szRcvFile[MAXFILENAME];        // Filename of received file (all but b-plus)
   char XferFile[MAXFILENAME];         // full pathname received file ( b-plus)
   char szFullPath[MAXFILENAME];       // full pathname for every protocol
   char szTempDir[MAXFILENAME];
   char szTempName[MAXFILENAME];       // temp filename, used in ShowXferBox
   int errorcnt;                       // number of errors occured during xfer
   int nackcount;                      // number of time nack txed or recieved during xfer
   int blocksdone;                     // number of record blocks xfered
   int bCancel;                        // Flag for user desire to cancel xfer
   DWORD xwaittime;                    // timeout period for protocol xfers
   int xcount;                         // number of rcved record bytes on xfer
   DWORD flen;                         // total expected bytes of received file
   long tflen;
   DWORD runcnt;                       // total bytes of existing file, for calulating xfer rate (runcnt-tflen) is used
   int rec_len;                        // length of record
   int rec_no;                         // current rec_no being xfered

   LPPW_CALLBACK_STRUCT lpcbs;         // pointer to the callback struct

   int setup;
   char dll_auto[12];
   char temp[66];
   FBPTR hProtocolFile;
   U8    bLostCarrier;                 // Did we have carrier & then lose it?
}PROTOSET;
#endif

#endif // _INC_PD
